// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	アニメーションクラス
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	定数
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// アニメーションの種類
const ANI_EASE_NONE		= "none";
const ANI_EASE_IN		= "power2.in";
const ANI_EASE_OUT		= "power2.out";
const ANI_EASE_INOUT	= "power2.inOut"
const ANI_BOUNCE_IN		= "bounce.in";
const ANI_BOUNCE_OUT	= "bounce.out";
const ANI_ELASTIC_OUT	= "elastic.out(2, 0.2)";
const ANI_BACK_OUT		= "back.out(4)";

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	文字列の調整(ユーザーで変更させないもの)
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
const YMSB_TXT_WIDTH_MEMBER				= 220;				// 団体戦メンバー
const YMSB_TXT_WIDTH_MEMBER_CLAMP		= 1;
const YMSB_FONT_SIZE_MEMBER				= 20;
const YMSB_FONT_SIZE_MEMBER_MIN			= 16;

const YMSB_TXT_WIDTH_LBNAME				= 230;				// 長期戦スコアのプレイヤー名
const YMSB_TXT_WIDTH_LBNAME_CLAMP		= 1;
const YMSB_FONT_SIZE_LBNAME				= 20;
const YMSB_FONT_SIZE_LBNAME_MIN			= 16;

const YMSB_TXT_WIDTH_STINGER			= 1400;				// スティンガー内のチーム名
const YMSB_TXT_WIDTH_STINGER_CLAMP		= 1;
const YMSB_FONT_SIZE_STINGER			= 250;
const YMSB_FONT_SIZE_STINGER_MIN		= 100;

const YMSB_TXT_WIDTH_STINGER_VS			= 1100;				// スティンガー内の中央の「VS」
const YMSB_TXT_WIDTH_STINGER_VS_CLAMP	= 1;
const YMSB_FONT_SIZE_STINGER_VS			= 250;
const YMSB_FONT_SIZE_STINGER_VS_MIN		= 50;

const YMSB_TXT_WIDTH_STINGER_NEXT		= 1400;				// スティンガー内の次戦カード
const YMSB_TXT_WIDTH_STINGER_NEXT_CLAMP	= 1;
const YMSB_FONT_SIZE_STINGER_NEXT		= 250;
const YMSB_FONT_SIZE_STINGER_NEXT_MIN	= 40;

const YMSB_TXT_WIDTH_COMMENT_NAME		= 580;				// コメントの名前
const YMSB_TXT_WIDTH_COMMENT_NAME_CLAMP	= 2;
const YMSB_FONT_SIZE_COMMENT_NAME		= 48;
const YMSB_FONT_SIZE_COMMENT_NAME_MIN	= 20;
/*
const YMSB_TXT_WIDTH_COMMENT_NOTE		= 580;				// コメントの内容
const YMSB_TXT_WIDTH_COMMENT_NOTE_CLAMP	= 4;
const YMSB_FONT_SIZE_COMMENT_NOTE		= 48;
const YMSB_FONT_SIZE_COMMENT_NOTE_MIN	= 40;
*/
const YMSB_TXT_WIDTH_WINNER				= 860;				// 勝利アニメーションの名前
const YMSB_TXT_WIDTH_WINNER_CLAMP		= 4;
const YMSB_FONT_SIZE_WINNER				= 160;
const YMSB_FONT_SIZE_WINNER_MIN			= 60;

const ANI_DUR_TXT_CHANGE				= 0.7;
const ANI_DUR_BOX_CHANGE				= 1.5;

const ANI_CHANGE_TYPE_DEFAULT			= "0";
const ANI_CHANGE_TYPE_COLOR				= "1";
const ANI_CHANGE_TYPE_ROLL_Y			= "2";

class YmsbAnime {

	constructor(txtOp, txtCSS, txtVorh, txtFrom, txtDelay, boxOp, boxCSS, boxVorh, boxFrom, boxDelay) {
		this.moveTo		= ANI_MOVE_DEFAULT;
		this.txtCurr	= "";
		this.txtAno		= "";
		this.txtProp	= "";
		this.txtOp		= txtOp
		this.txtCSS		= txtCSS;
		this.txtVorh	= txtVorh;
		this.txtFrom	= txtFrom;
		this.txtDelay	= txtDelay;
		this.txtTl		= null;
		this.txtTlParamOn = function (rotate, css, txt) {
			return {
				duration: ANI_DUR_TXT_CHANGE, opacity: 1.0, overwrite: "auto", rotationX: rotate, ease: ANI_EASE_OUT,
				onStart: YmsbAnime.callBackTextUpdate(css, txt, "")
			}
		};
		this.txtTlParamOff = function (rotate) {
			return { duration: ANI_DUR_TXT_CHANGE, opacity: 1.0, overwrite: "auto", rotationX: rotate, ease: ANI_EASE_IN }
		};
		this.txtTlParamDef = function (rotate) { return { transformPerspective: "50px", rotationX: rotate, transformOrigin: "50% 50%" } };
		this.boxCurrURL	= "";
		this.boxCurrCSS	= "";
		this.boxOp		= boxOp;
		this.boxCSS		= boxCSS;
		this.boxVorh	= boxVorh;
		this.boxFrom	= boxFrom;
		this.boxDelay	= boxDelay;
		this.boxTl		= null;

		this.isAniUpdate = false;
	}

	// ■■ TimeLineアニメの再生
	animeRestart() {
		if (null != this.txtTl) {
			this.txtTl.restart();
			this.isAniUpdate = false;
		}
	}

	// ■■ 表示
	animeOn(txtNew, txtAno, cssTxtProp, imgURL, cssBoxProp, isBoxChange) {
		if (("" != imgURL) || ("" != cssBoxProp)) {
			this.animeOnImg(imgURL, cssBoxProp, isBoxChange);
		}

		let strText = txtNew;
		if (!(isString(strText))){
			strText = String(txtNew);
		}
		if ("" != strText) {
			this.animeOnTxt(strText, txtAno, cssTxtProp);
		}
	}

	animeOnImg(imgURL, cssBoxProp, isBoxChange) {
		let pBoxFrom;
		let pBoxTo;
		const setBoxCSS = this.boxCSS;
		let moveX = "0px";
		let moveY = "0px";
		let boxParam = function (op) {
			return { duration: ANI_DUR_BOX_CHANGE, opacity: op, overwrite: "auto" }
		};

		if (YMSB_VIRT == this.boxVorh) { moveY = this.boxFrom; }
		else /* YMSB_HORI */ { moveX = this.boxFrom; }
		pBoxFrom = { x: moveX, y: moveY, opacity: 0.0 };
		pBoxTo = {
			x: this.moveTo, y: this.moveTo,
			duration: ANI_DUR_BASE, ease: ANI_EASE_OUT, delay: this.boxDelay, opacity: this.boxOp,
			onStart: YmsbAnime.callBackImageUpdate(setBoxCSS, imgURL, cssBoxProp)
		};

		gsap.timeline()
			.set(setBoxCSS, pBoxFrom)
			.to(setBoxCSS, pBoxTo);
		if (isBoxChange) {
			this.boxTl = gsap.timeline({ repeat: -1, repeatRefresh: true })
				.to(setBoxCSS, boxParam(0.0),)
				.to(setBoxCSS, boxParam(1.0), YMSB_BOX_CHANGE_TIME);
		}
		this.boxCurrURL = imgURL;
		this.boxCurrCSS = cssBoxProp;
	}

	animeOnTxt(txtNew, txtAno, cssTxtProp) {
		let pTxtFrom;
		let pTxtTo;
		const setTxtCSS = this.txtCSS;
		let moveX = "0px";
		let moveY = "0px";

		if (YMSB_VIRT == this.txtVorh) { moveY = this.txtFrom; }
		else /* YMSB_HORI */ { moveX = this.txtFrom; }
		pTxtFrom = { x: moveX, y: moveY, opacity: 0.0 };
		pTxtTo = {
			x: this.moveTo, y: this.moveTo,
			duration: ANI_DUR_BASE, ease: ANI_EASE_OUT, delay: this.txtDelay, opacity: this.txtOp,
			onStart: YmsbAnime.callBackTextUpdate(setTxtCSS, txtNew, cssTxtProp)
		};
		gsap.timeline()
			.set(setTxtCSS, pTxtFrom)
			.to(setTxtCSS, pTxtTo);

		// 別名表示はタイムラインを設定し、cState.checkData()内で開始する
		if ("" != txtAno) {
			this.txtTl = gsap.timeline({ repeat: -1 });
			this.setAnimeAutoChange(setTxtCSS, txtNew, txtAno);
			this.txtTl.pause();
			this.isAniUpdate = true;
		}
		this.txtAno = txtAno;
		this.txtCurr = txtNew;
		this.txtProp = cssTxtProp;
	}

	// ■■ 非表示
	animeOff() {
		if ("" != this.boxCurrURL || "" != this.boxCurrCSS) {
			this.animeOffImg();
		}

		if ("" != this.txtCurr) {
			this.animeOffTxt();
		}
	}

	animeOffImg() {
		let pBoxTo;
		let moveX = "0px";
		let moveY = "0px";

		if (YMSB_VIRT == this.boxVorh) { moveY = this.boxFrom; }
		else /* YMSB_HORI */ { moveX = this.boxFrom; }
		pBoxTo = {
			x: moveX, y: moveY,
			duration: ANI_DUR_BASE, ease: ANI_EASE_IN, delay: ANI_DELY_OFF_BOX, opacity: 0.0
		};
		gsap.to(this.boxCSS, pBoxTo);
		if (null != this.boxTl) {
			this.boxTl.kill();
			this.boxTl = null;
		}
		this.boxCurrURL = "";
		this.boxCurrCSS = "";
	}

	animeOffTxt() {
		let pTxtTo;
		let moveX = "0px";
		let moveY = "0px";

		if (YMSB_VIRT == this.txtVorh) { moveY = this.txtFrom; }
		else /* YMSB_HORI */ { moveX = this.txtFrom; }
		pTxtTo = {
			x: moveX, y: moveY,
			duration: ANI_DUR_BASE, ease: ANI_EASE_IN, delay: ANI_DELY_OFF_TXT, opacity: 0.0
		};
		gsap.to(this.txtCSS, pTxtTo);
		if (null != this.txtTl) {
			this.txtTl.kill();
			this.txtTl = null;
			this.txtAno = "";
		}
		this.txtCurr = "";
		this.txtProp = "";
	}

	// ■■ 更新
	animeUpdate(txtNew, txtAno, cssTxtProp, imgURL, cssBoxProp, isBoxChange, type = ANI_CHANGE_TYPE_DEFAULT) {
		const setBoxCSS = this.boxCSS;
		if ("" != setBoxCSS) {
			this.animeUpdateBox(setBoxCSS, imgURL, cssBoxProp, isBoxChange);
		}
		let strText = txtNew;
		if (!(isString(strText))){
			strText = String(txtNew);
		}
		const setTxtCSS = this.txtCSS;
		if ("" != setTxtCSS) {
			this.animeUpdateTxt(setTxtCSS, strText, txtAno, cssTxtProp, type);
		}
	}

	animeUpdateBox(setBoxCSS, imgURL, cssBoxProp, isBoxChange) {
		if		(("" != this.boxCurrURL || "" != this.boxCurrCSS) && ("" == imgURL) && ("" == cssBoxProp)) {
			this.animeOffImg();
		}
		else if	(("" == this.boxCurrURL && "" == this.boxCurrCSS) && ("" != imgURL || "" != cssBoxProp)) {
			this.animeOnImg(imgURL, cssBoxProp, isBoxChange);
		}
		else if	((imgURL == this.boxCurrURL) && (JSON.stringify(cssBoxProp) === JSON.stringify(this.boxCurrCSS))){
			// nop
		}
		else {
			let pBoxOut;
			let pBoxIn;
			let moveX = "0px";
			let moveY = "0px";
			if (YMSB_VIRT == this.boxVorh) { moveY = this.boxFrom; }
			else { moveX = this.boxFrom; } // YMSB_HORI
			pBoxOut = {
				x: moveX, y: moveY, duration: ANI_DUR_BASE, ease: ANI_EASE_IN, delay: ANI_DELY_UPDATE,
				onStart: function () { if (null != this.boxTl) { this.boxTl.pause(); } },
				onComplete: YmsbAnime.callBackImageUpdate(setBoxCSS, imgURL, cssBoxProp)
			};
			pBoxIn = {
				x: this.moveTo, y: this.moveTo, duration: ANI_DUR_BASE, ease: ANI_EASE_OUT,
				onComplete: function () { if (null != this.boxTl) { this.boxTl.resume(); } }
			};
			gsap.timeline()
				.to(setBoxCSS, pBoxOut)
				.to(setBoxCSS, pBoxIn);
			this.boxCurrURL = imgURL;
			this.boxCurrCSS = cssBoxProp;
		}
	}

	animeUpdateTxt(setTxtCSS, txtNew, txtAno, cssTxtProp, type) {
		if (("" != this.txtCurr) && ("" == txtNew)) {
			this.animeOffTxt();
		}
		else if (("" == this.txtCurr) && ("" != txtNew)) {
			this.animeOnTxt(txtNew, txtAno, cssTxtProp);
		}
		else if ((txtNew == this.txtCurr) && (txtAno == this.txtAno) && (JSON.stringify(cssTxtProp) === JSON.stringify(this.txtProp))) {
			// nop
		}
		else {
			this.setAnimeUpdateTxt(setTxtCSS, txtNew, cssTxtProp, type);
			if ("" != txtAno) {
				if (null != this.txtTl) {
					this.txtTl.clear(true);
				}
				else {
					this.txtTl = gsap.timeline({ repeat: -1 });
				}
				this.setAnimeAutoChange(setTxtCSS, txtNew, txtAno);
				this.txtTl.pause();
				this.isAniUpdate = true;
			}
			else if (("" == txtAno) && (null != this.txtTl)) {
				this.txtTl.kill();
				this.txtTl = null;
				this.isAniUpdate = true;
			}
			else {
				// nop
			}
			this.txtCurr = txtNew;
			this.txtAno = txtAno;
			this.txtProp = cssTxtProp;
		}
	}

	// ■■ テキスト自動更新のタイムライン設定
	setAnimeAutoChange(setTxtCSS, txtNew, txtAno) {
		this.txtTl
			.set(setTxtCSS, this.txtTlParamDef(0))
			.to(setTxtCSS, this.txtTlParamOff(-90), YMSB_TXT_CHANGE_TIME)
			.set(setTxtCSS, this.txtTlParamDef(90))
			.to(setTxtCSS, this.txtTlParamOn(0, setTxtCSS, txtAno))
			.to(setTxtCSS, this.txtTlParamOff(-90), YMSB_TXT_CHANGE_TIME)
			.set(setTxtCSS, this.txtTlParamDef(90))
			.to(setTxtCSS, this.txtTlParamOn(0, setTxtCSS, txtNew));
	}

	// ■■ テキストアニメーションの設定
	setAnimeUpdateTxt(setTxtCSS, txtNew, cssTxtProp, type) {
		let pTxtOut;
		let pTxtIn;
		let moveX = "0px";
		let moveY = "0px";

		if (YMSB_VIRT == this.txtVorh) { moveY = this.txtFrom; }
		else /* YMSB_HORI */ { moveX = this.txtFrom; }

		switch (type) {
			case ANI_CHANGE_TYPE_ROLL_Y:
				pTxtOut = {
					x: moveX, y: moveY, duration: 0.2, rotationY: 90, delay: 0.3, ease: ANI_EASE_IN,
					onStart: function () { if (null != this.txtTl) { this.txtTl.pause(); } }
				};
				pTxtIn = {
					x: this.moveTo, y: this.moveTo, duration: 0.2, rotationY: 0, opacity: this.txtOp,
					onStart: YmsbAnime.callBackTextUpdate(setTxtCSS, txtNew, cssTxtProp)
				};
				gsap.timeline()
					.set(setTxtCSS, { transformPerspective: "200px", rotationY: 0 })
					.to(setTxtCSS, { duration: 0.3, delay: ANI_DELY_UPDATE, scale: 1.6 })
					.to(setTxtCSS, pTxtOut)
					.set(setTxtCSS, { rotationY: -90 })
					.to(setTxtCSS, pTxtIn)
					.to(setTxtCSS, { duration: 0.15, scale: 1.0, delay: 0.2 });
				break;
			case ANI_CHANGE_TYPE_COLOR:
				gsap.to(setTxtCSS,{duration: ANI_DUR_BASE, delay: ANI_DELY_UPDATE,
					color: cssTxtProp["color"],
					textShadow: cssTxtProp["text-shadow"],
					top: cssTxtProp["top"],
					height: cssTxtProp["height"],
					onComplete: YmsbAnime.callBackTextUpdate(setTxtCSS, txtNew, cssTxtProp)
					});
				break;
			default:
				pTxtOut = {
					x: moveX, y: moveY, duration: ANI_DUR_BASE, ease: ANI_EASE_IN, opacity: 1.0, delay: ANI_DELY_UPDATE,
					onStart: function () { if (null != this.txtTl) { this.txtTl.pause(); } }
				};
				pTxtIn = {
					x: this.moveTo, y: this.moveTo, duration: ANI_DUR_BASE, ease: ANI_EASE_OUT, opacity: this.txtOp,
					onStart: YmsbAnime.callBackTextUpdate(setTxtCSS, txtNew, cssTxtProp)
				};
				gsap.timeline()
					.to(setTxtCSS, pTxtOut)
					.to(setTxtCSS, pTxtIn);
				break;
		}
	}

	// ■■ テキスト更新コールバック
	static callBackTextUpdate(cssName, strText, cssTxtProp) {
		return () => {
			if ("" != cssTxtProp) {
				jQuery(cssName).css(cssTxtProp);
			}
			strText = strText.replace(/\\n/g, "\n");
			jQuery(cssName).textWithLF(YmsbAnime.fitTextWidth(strText, cssName));
		};
	}

	// ■■ 画像更新コールバック
	static callBackImageUpdate(cssName, imgURL, cssBoxProp) {
		return () => {
			if ("" != cssBoxProp) {
				jQuery(cssName).css(cssBoxProp);
			}
			else {
				const newImage = new Image();
				newImage.src = imgURL;
				newImage.onload = function () {
					jQuery(cssName).attr("src", imgURL);
				}
			}
		};
	}

	// ■■ テキストの長さに合わせてフォントサイズを変更する ■■
	static fitTextWidth(text, id) {
		let viewText = new String(text);
		let maxFontSize;
		let minFontSize;
		let maxTxtSize;
		let maxClamp;

		switch (id) {
			case SbCSS.TXT_STAGE:
				maxFontSize = YMSB_FONT_SIZE_STAGE;
				minFontSize = YMSB_FONT_SIZE_STAGE_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_STAGE;
				maxClamp	= YMSB_TXT_WIDTH_STAGE_CLAMP;
				break;

			case SbCSS.TXT_TEAM_1P:
			case SbCSS.TXT_TEAM_2P:
				maxFontSize = YMSB_FONT_SIZE_TEAM;
				minFontSize = YMSB_FONT_SIZE_TEAM_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_TEAM;
				maxClamp	= YMSB_TXT_WIDTH_TEAM_CLAMP;
				break;

			case SbCSS.TXT_NOW_1P:
			case SbCSS.TXT_NOW_2P:
				maxFontSize = YMSB_FONT_SIZE_NOW;
				minFontSize = YMSB_FONT_SIZE_NOW_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_NOW;
				maxClamp	= YMSB_TXT_WIDTH_NOW_CLAMP;
				break;

			case SbCSS.TXT_EVENT_TOP:
			case SbCSS.TXT_EVENT_BOTTOM:
				maxFontSize = YMSB_FONT_SIZE_EVENT;
				minFontSize = YMSB_FONT_SIZE_EVENT_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_EVENT;
				maxClamp	= YMSB_TXT_WIDTH_EVENT_CLAMP;
				break;

			case SbCSS.TXT_MEMBER:
				maxFontSize = YMSB_FONT_SIZE_MEMBER;
				minFontSize = YMSB_FONT_SIZE_MEMBER_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_MEMBER;
				maxClamp	= YMSB_TXT_WIDTH_MEMBER_CLAMP;
				break;

			case SbCSS.TXT_LB_NAME_1P:
			case SbCSS.TXT_LB_NAME_2P:
				maxFontSize = YMSB_FONT_SIZE_LBNAME;
				minFontSize = YMSB_FONT_SIZE_LBNAME_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_LBNAME;
				maxClamp	= YMSB_TXT_WIDTH_LBNAME_CLAMP;
				break;

			case SbCSS.TXT_STINGER_1P:
			case SbCSS.TXT_STINGER_2P:
			case SbCSS.TXT_STINGER_EVENT:
				maxFontSize = YMSB_FONT_SIZE_STINGER;
				minFontSize = YMSB_FONT_SIZE_STINGER_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_STINGER;
				maxClamp	= YMSB_TXT_WIDTH_STINGER_CLAMP;
				break;

			case SbCSS.TXT_STINGER_VS:
				maxFontSize = YMSB_FONT_SIZE_STINGER_VS;
				minFontSize = YMSB_FONT_SIZE_STINGER_VS_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_STINGER_VS;
				maxClamp	= YMSB_TXT_WIDTH_STINGER_VS_CLAMP;
				break;

			case SbCSS.TXT_STINGER_NEXT_1P:
			case SbCSS.TXT_STINGER_NEXT_2P:
				maxFontSize = YMSB_FONT_SIZE_STINGER_NEXT;
				minFontSize = YMSB_FONT_SIZE_STINGER_NEXT_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_STINGER_NEXT;
				maxClamp	= YMSB_TXT_WIDTH_STINGER_NEXT_CLAMP;
				break;

			case SbCSS.TXT_COMMENT_NAME_1P:
			case SbCSS.TXT_COMMENT_NAME_2P:
				maxFontSize = YMSB_FONT_SIZE_COMMENT_NAME;
				minFontSize = YMSB_FONT_SIZE_COMMENT_NAME_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_COMMENT_NAME;
				maxClamp	= YMSB_TXT_WIDTH_COMMENT_NAME_CLAMP;
				break;
/*
			case SbCSS.TXT_COMMENT_NOTE_1P:
			case SbCSS.TXT_COMMENT_NOTE_2P:
				maxFontSize = YMSB_FONT_SIZE_COMMENT_NOTE;
				minFontSize = YMSB_FONT_SIZE_COMMENT_NOTE_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_COMMENT_NOTE;
				maxClamp	= YMSB_TXT_WIDTH_COMMENT_NOTE_CLAMP;
				break;
*/
			case SbCSS.TXT_WINNER:
				maxFontSize = YMSB_FONT_SIZE_WINNER;
				minFontSize = YMSB_FONT_SIZE_WINNER_MIN;
				maxTxtSize	= YMSB_TXT_WIDTH_WINNER;
				maxClamp	= YMSB_TXT_WIDTH_WINNER_CLAMP;
				break;

			default:
				return viewText;
		}

		// 指定サイズより文字列長が短くなるまでフォントサイズを調整する
		let canvas = document.getElementById("MeasureText");
		let context = canvas.getContext("2d");
		const currFont = arrFonts[cFont.FONT_NAME][cFont.currFont];
		context.font = maxFontSize + "px " + currFont;
		let metrics = context.measureText(viewText);
		let txtWidth = metrics.width;
		let fontSize;
		for (fontSize = maxFontSize; txtWidth > maxTxtSize && minFontSize < fontSize; fontSize --) {
			context.font = fontSize + "px " + currFont;
			metrics = context.measureText(viewText);
			txtWidth = metrics.width;
		}
		const setFontSize = fontSize + "px";
		jQuery(id).css({"font-size":setFontSize, "line-height":setFontSize});

		// 改行を許せる場合は改行し文字列長を調整した上で省略文字を付加する
		if (minFontSize >= fontSize) {
			let flagWrap = false;
			context.font = fontSize + currFont;
			let sliceSize = 1;
			let sliceText = viewText;
			for (maxTxtSize = maxClamp * maxTxtSize; maxTxtSize < txtWidth; sliceSize++ ) {
				sliceText = viewText.slice(0, viewText.length - sliceSize); 
				metrics = context.measureText(sliceText);
				txtWidth = metrics.width;
				flagWrap = true;
			}
			if (flagWrap) {
				viewText = sliceText;
//				viewText = viewText.slice(0, viewText.length - YMSB_TXT_CLAMP.length);
				viewText += YMSB_TXT_CLAMP;
			}
		}
		if (maxClamp != 1) {
			jQuery(id).css({"white-space":"normal"});
		}
		else {
			jQuery(id).css({"white-space":"nowrap"});
		}

		return viewText;
	}
}

function isString(value) {
	if (typeof value === "string" || value instanceof String) {
		return true;
	}
	else {
		return false;
	}
}