// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	下部表示管理
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ ステージ名クラス
class YmsbBottomCheck extends YmsbCheck{

	BOTTOM_OFF			= 0;
	BOTTOM_LB			= 1;
	BOTTOM_NEXT			= 2;
	BOTTOM_IMAGE		= 3;
	BOTTOM_TEXT			= 4;

	constructor(txtFrom, boxFrom) {
		super();
		this.LB			= new YmsbAnimeLB(ANIME_LB_TXT_VH, ANIME_LB_TXT_01, ANIME_LB_TXT_02, ANIME_LB_BOX_01);
		this.Next		= new Array(3);
		this.Next[0]	= new YmsbAnime(
			1.0, SbCSS.TXT_NEXT_1P, YMSB_VIRT, txtFrom, ANI_DELY_ON_TXT_BOTTOM,
			0.7, SbCSS.BOX_NEXT_1P, YMSB_VIRT, boxFrom, ANI_DELY_ON_BOX_BOTTOM);
		this.Next[1]	= new YmsbAnime(
			1.0, SbCSS.TXT_NEXT_2P, YMSB_VIRT, txtFrom, ANI_DELY_ON_TXT_BOTTOM,
			0.7, SbCSS.BOX_NEXT_2P, YMSB_VIRT, boxFrom, ANI_DELY_ON_BOX_BOTTOM);
		this.Next[2]	= new YmsbAnime(
			1.0, SbCSS.TXT_NEXT_VS, YMSB_VIRT, txtFrom, ANI_DELY_ON_TXT_BOTTOM,
			"", "", "", "", "");
		this.Image		= new YmsbAnime(
			0.0, "", "", "", "",
			1.0, SbCSS.BOX_BOTTOM, YMSB_VIRT, boxFrom, ANI_DELY_ON_BOX_BOTTOM);
		this.Text		= new YmsbAnime(
			1.0, SbCSS.TXT_BOTTOM, YMSB_VIRT, txtFrom, ANI_DELY_ON_TXT_BOTTOM,
			0.0, "", "", "", "");
		this.currBottom	= YMSB_OFF;
	}

	// テキスト入替アニメの再開
	animeRestart() {
		this.Text.animeRestart();
		this.LB.lbNames[0].animeRestart();
		this.LB.lbNames[1].animeRestart();
	}

	// データ切り分け
	checkData() {
		const newBottom = Number(jsonData[SbJSON.BOTTOM_VIEW]);
		if		(YMSB_OFF_ON == currScoreBoard) {
			this.bottomOn(newBottom);
		}
		else if	(YMSB_ON_OFF == currScoreBoard) {
			this.bottomOff();
		}
		else if (YMSB_ON == currScoreBoard) {
			this.bottomUpdate(newBottom);
		}
		else {
			// nop
		}
		this.currBottom = newBottom;

		return (this.Text.isAniUpdate || this.LB.lbNames[0].isAniUpdate || this.LB.lbNames[1].isAniUpdate);
	}

	// 下段ON
	bottomOn(newBottom) {
		switch(newBottom) {
			case this.BOTTOM_LB:
				this.LB.animeOn();
				break;

			case this.BOTTOM_NEXT:
				const cssPropBox = {"display":"block"};
				for (let i = 0; i < 2; i++) {
					const txtNew = jsonData[JSON_NEXT_NAME[i]];
					this.Next[i].animeOn(txtNew, "", "", "", cssPropBox, false);
				}
				this.Next[2].animeOn(YMSB_TXT_NEXT, "", "", "", "", false);
				break;

			case this.BOTTOM_IMAGE:
				const imgURL  = jsonData[SbJSON.BOTTOM_IMAGE];
				let cssProp = "";
				if ("" != imgURL) {
					cssProp = {
						"display":"block",
						"background-image" : "url(" + YMSB_URL_USER + imgURL + YMSB_IMAGE_EXT + ")",
						"left"             : arrBottomSize[newBottomSize][BOTTOM_SIZE_LEFT],
						"max-width"        : arrBottomSize[newBottomSize][BOTTOM_SIZE_WIDTH]
					}
				}
				this.Image.animeOn("", "", "", imgURL, cssProp, false);
				break;

			case this.BOTTOM_TEXT:
				const txtNew = jsonData[SbJSON.BOTTOM_TEXT];
				this.Text.animeOn(txtNew[0], txtNew[1], "", "", "", false);
				break;

			default:
				break;
		}
	}

	// 下段OFF
	bottomOff() {
		switch(this.currBottom) {
			case this.BOTTOM_LB:
				this.LB.animeOff();
				break;
			case this.BOTTOM_NEXT:
				for (let i = 0; i < 3; i++) {
					this.Next[i].animeOff();
				}
				break;
			case this.BOTTOM_IMAGE:
				this.Image.animeOff();
				break;
			case this.BOTTOM_TEXT:
				this.Text.animeOff();
				break;
			default:
				break;
		}
	}

	// 下段更新
	bottomUpdate(newBottom) {
		if (newBottom != this.currBottom) {
			this.bottomOff();
			this.bottomOn(newBottom);
		}
		else {
			switch(newBottom) {
				case this.BOTTOM_LB:
					this.LB.animeUpdate();
					break;

				case this.BOTTOM_NEXT:
					const cssPropBox = {"display":"block"};
					for (let i = 0; i < 2; i++) {
						const txtNew = jsonData[JSON_NEXT_NAME[i]];
						this.Next[i].animeUpdate(txtNew, "", "", "", cssPropBox, false);
					}
					this.Next[2].animeUpdate(YMSB_TXT_NEXT, "", "", "", "", false);
					break;

				case this.BOTTOM_IMAGE:
					const imgURL  = jsonData[SbJSON.BOTTOM_IMAGE];
					let cssProp = "";
					if ("" != imgURL) {
						cssProp = {
							"display":"block",
							"background-image" : "url(" + YMSB_URL_USER + imgURL + YMSB_IMAGE_EXT + ")",
							"left"             : arrBottomSize[newBottomSize][BOTTOM_SIZE_LEFT],
							"max-width"        : arrBottomSize[newBottomSize][BOTTOM_SIZE_WIDTH]
						}
					}
					this.Image.animeUpdate("", "", "", imgURL, cssProp, false);
					break;

				case this.BOTTOM_TEXT:
					const txtNew = jsonData[SbJSON.BOTTOM_TEXT];
					this.Text.animeUpdate(txtNew[0], txtNew[1], "", "", "", false);
					break;

				default:
					break;
			}
		}
	}
}
