// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//  CSSのIDクラス
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
const TYPE_BOX			= "Box";
const TYPE_TXT			= "Txt";
const ID_SIDE			= "Side";
const ID_TEAM			= "Team";
const ID_SCORE			= "Score";
const ID_NOW			= "Now";
const ID_STAR			= "Star";
const ID_LOGO_TOP		= "LogoTop";
const ID_LOGO_CHARA		= "LogoChara";
const ID_MEMBER_NAME	= "MemberName";
const ID_MEMBER_LIFE	= "MemberLife";
const ID_LB_NAME		= "LBName";
const ID_LB_SCORE		= "LBScore";
const ID_NEXT			= "Next";
const ID_STINGER		= "Stinger";
const ID_STINGER_NEXT	= "StingerNext";
const ID_COMMENT		= "Comment";
const ID_COMMENT_NAME	= "CommentName";
const ID_COMMENT_NOTE	= "CommentNote";

class SbCSS {
	static retID			= function(BoxOrTxt, id, side) {return "#" + BoxOrTxt + id + side + "p"};
	static retNumberID		= function(BoxOrTxt, id, side, number) {
		const numberNum  = ('00' + number).slice(-2);
		return "#" + BoxOrTxt + id + side +"p_" + numberNum;	
	}
	static TXT_STAGE				= "#TxtStage";
	static TXT_TEAM					= ".Txt.Team";
	static TXT_TEAM_1P				= "#TxtTeam1p";
	static TXT_TEAM_2P				= "#TxtTeam2p";
	static TXT_SCORE				= ".Txt.Score";
	static TXT_SCORE_1P				= "#TxtScore1p";
	static TXT_SCORE_2P				= "#TxtScore2p";
	static TXT_NOW					= ".Txt.Now";
	static TXT_NOW_1P				= "#TxtNow1p";
	static TXT_NOW_2P				= "#TxtNow2p";
	static TXT_STAR					= ".Txt.Star";
	static TXT_STAR_1P				= "#TxtStar1p";
	static TXT_STAR_2P				= "#TxtStar2p";
	static TXT_EVENT				= ".Txt.Event";
	static TXT_EVENT_TOP			= "#TxtEventTop";
	static TXT_EVENT_BOTTOM			= "#TxtEventBottom";
	static TXT_MEMBER				= ".Txt.Member";
	static TXT_MEMBER_NAME_1P		= ".Txt.Member.Name1p";
	static TXT_MEMBER_NAME_2P		= ".Txt.Member.Name2p";
	static TXT_MEMBER_LIFE_1P		= ".Txt.Member.Life1p";
	static TXT_MEMBER_LIFE_2P		= ".Txt.Member.Life2p";
	static TXT_STINGER				= ".Txt.Stinger"
	static TXT_STINGER_1P			= "#TxtStinger1p";
	static TXT_STINGER_2P			= "#TxtStinger2p";
	static TXT_STINGER_VS			= "#TxtStingerVS";
	static TXT_STINGER_EVENT		= "#TxtStingerEvent";
	static TXT_STINGER_NEXT			= ".Txt.Stinger.Next";
	static TXT_STINGER_NEXT_1P		= "#TxtStingerNext1p";
	static TXT_STINGER_NEXT_2P		= "#TxtStingerNext2p";
	static TXT_STINGER_NEXT_CENTER	= "#TxtStingerNextCenter";
	static TXT_COMMENT_NAME			= ".Txt.Comment.Name";
	static TXT_COMMENT_NAME_1P		= "#TxtCommentName1p";
	static TXT_COMMENT_NAME_2P		= "#TxtCommentName2p";
	static TXT_COMMENT_NOTE			= ".Txt.Comment.Note";
	static TXT_COMMENT_NOTE_1P		= "#TxtCommentNote1p";
	static TXT_COMMENT_NOTE_2P		= "#TxtCommentNote2p";
	static TXT_WINNER				= "#TxtWinAnime";
	static TXT_NEXT					= ".Txt.Bottom.Next";
	static TXT_NEXT_VS				= "#TxtNextVS";
	static TXT_NEXT_1P				= "#TxtNext1p";
	static TXT_NEXT_2P				= "#TxtNext2p";
	static TXT_BOTTOM				= "#TxtBottom";
	static TXT_LB_NAME				= ".Txt.LB.Name";
	static TXT_LB_NAME_1P			= "#TxtLBName1p";
	static TXT_LB_NAME_2P			= "#TxtLBName2p";
	static TXT_LB_SCORE				= ".Txt.LB.Score";
	static TXT_LB_TOP				= ".Txt.LB.Top";
	static TXT_LB_BOTTOM			= ".Txt.LB.Bottom";
	static BOX_BACK					= "#BoxBack";
	static BOX_SIDE					= ".Box.Side";
	static BOX_STAGE				= "#BoxStage";
	static BOX_TEAM					= ".Box.Team";
	static BOX_TEAM_1P				= "#BoxTeam1p";
	static BOX_TEAM_2P				= "#BoxTeam2p";
	static BOX_SCORE				= ".Box.Score";
	static BOX_SCORE_1P				= "#BoxScore1p";
	static BOX_SCORE_2P				= "#BoxScore2p";
	static BOX_NOW					= ".Box.Now";
	static BOX_NOW_1P				= "#BoxNow1p";
	static BOX_NOW_2P				= "#BoxNow2p";
	static BOX_STAR					= ".Box.Star";
	static BOX_STAR_1P				= "#BoxStar1p";
	static BOX_STAR_2P				= "#BoxStar2p";
	static BOX_EVENT				= ".Box.Event";
	static BOX_EVENT_TOP			= "#BoxEventTop";
	static BOX_EVENT_BOTTOM			= "#BoxEventBottom";
	static BOX_LOGO					= "Box.Logo";
	static BOX_LOGO_TOP_1P			= "#BoxLogoTop1p";
	static BOX_LOGO_TOP_2P			= "#BoxLogoTop2p";
	static BOX_LOGO_CHARA			= "Box.Logo.Chara";
	static BOX_LOGO_CHARA_1P		= "#BoxLogoChara1p";
	static BOX_LOGO_CHARA_2P		= "#BoxLogoChara2p";
	static BOX_MEMBER				= ".Box.Member";
	static BOX_MEMBER_NAME_1P		= ".Box.Member.Name1p";
	static BOX_MEMBER_NAME_2P		= ".Box.Member.Name2p";
	static BOX_MEMBER_LIFE_1P		= ".Box.Member.Life1p";
	static BOX_MEMBER_LIFE_2P		= ".Box.Member.Life2p";
	static BOX_BOTTOM				= "#BoxBottom";
	static BOX_LB_BACK				= "#BoxLBBack";
	static BOX_NEXT					= ".Box.Next";
	static BOX_NEXT_1P				= "#BoxNext1p";
	static BOX_NEXT_2P				= "#BoxNext2p";
	static BOX_STINGER_WINDOW		= ".BoxSw div > span";
	static BOX_STINGER_WINDOW_ALL	= "#BoxSwAll";
	static BOX_STINGER_WINDOW_V2_1 	= "#BoxSwVirt21";
	static BOX_STINGER_WINDOW_V2_2 	= "#BoxSwVirt22";
	static BOX_STINGER_WINDOW_V4	= ".BoxSW div.BoxSwVirt4 > span";
	static BOX_STINGER_WINDOW_V4_1 	= "#BoxSwVirt41";
	static BOX_STINGER_WINDOW_V4_2 	= "#BoxSwVirt42";
	static BOX_STINGER_WINDOW_V4_3 	= "#BoxSwVirt43";
	static BOX_STINGER_WINDOW_V4_4 	= "#BoxSwVirt44";
	static BOX_STINGER_WINDOW_V8	= ".BoxSW div.BoxSwVirt8 > span";
	static BOX_STINGER_WINDOW_V8_1 	= "#BoxSwVirt81";
	static BOX_STINGER_WINDOW_V8_2 	= "#BoxSwVirt82";
	static BOX_STINGER_WINDOW_V8_3 	= "#BoxSwVirt83";
	static BOX_STINGER_WINDOW_V8_4 	= "#BoxSwVirt84";
	static BOX_STINGER_WINDOW_V8_5 	= "#BoxSwVirt85";
	static BOX_STINGER_WINDOW_V8_6 	= "#BoxSwVirt86";
	static BOX_STINGER_WINDOW_V8_7 	= "#BoxSwVirt87";
	static BOX_STINGER_WINDOW_V8_8 	= "#BoxSwVirt88";
	static BOX_STINGER_WINDOW_H2_1 	= "#BoxSwHori21";
	static BOX_STINGER_WINDOW_H2_2 	= "#BoxSwHori22";
	static BOX_STINGER_WINDOW_H4	= ".BoxSW div.BoxSwHori4 > span";
	static BOX_STINGER_WINDOW_H4_1 	= "#BoxSwHori41";
	static BOX_STINGER_WINDOW_H4_2 	= "#BoxSwHori42";
	static BOX_STINGER_WINDOW_H4_3 	= "#BoxSwHori43";
	static BOX_STINGER_WINDOW_H4_4 	= "#BoxSwHori44";
	static BOX_STINGER_WINDOW_H8	= ".BoxSW div.BoxSwHori8 > span";
	static BOX_STINGER_WINDOW_H8_1 	= "#BoxSwHori81";
	static BOX_STINGER_WINDOW_H8_2 	= "#BoxSwHori82";
	static BOX_STINGER_WINDOW_H8_3 	= "#BoxSwHori83";
	static BOX_STINGER_WINDOW_H8_4 	= "#BoxSwHori84";
	static BOX_STINGER_WINDOW_H8_5 	= "#BoxSwHori85";
	static BOX_STINGER_WINDOW_H8_6 	= "#BoxSwHori86";
	static BOX_STINGER_WINDOW_H8_7 	= "#BoxSwHori87";
	static BOX_STINGER_WINDOW_H8_8 	= "#BoxSwHori88";
	static BOX_BACK_STINGER			= ".Box.Back.Stinger";
	static BOX_BACK_STINGER_DEF		= "#BoxBackDef";
	static BOX_BACK_STINGER_GRAY	= "#BoxBackGray";
	static BOX_COMMENT				= ".Box.Comment";
	static BOX_COMMENT_1P			= "#BoxComment1p";
	static BOX_COMMENT_2P			= "#BoxComment2p";
	static BOX_WINNER				= "#BoxWinAnime";
	static BOX_WHITE_OUT			= "#BoxWhiteOut";
	static BOX_WINNER_SHADE			= "#BoxWinShade";
	static BOX_SPLASH				= "#SplWinAnime";
	static BOX_SPLASH_NH			= "SplWinAnime";
	static MASK_STINGER				= "#MaskStinger";
}

