// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	イベント名の更新・アニメーション表示
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ イベント名クラス
class YmsbEventCheck extends YmsbCheck {

	EVENT_OFF    = 0;
	EVENT_TOP    = 1;
	EVENT_BOTTOM = 2;

	constructor(moveTxtTop, moveBoxTop, moveTxtBottom, moveBoxBottom) {
		super();
		this.eventTop		= new YmsbAnime(
			1.0, SbCSS.TXT_EVENT_TOP,		YMSB_VIRT, moveTxtTop,		ANI_DELY_ON_TXT_EVENT, 
			1.0, SbCSS.BOX_EVENT_TOP,		YMSB_VIRT, moveBoxTop,		ANI_DELY_ON_BOX_EVENT);
		this.eventBottom	= new YmsbAnime(
			1.0, SbCSS.TXT_EVENT_BOTTOM,	YMSB_VIRT, moveTxtBottom,	ANI_DELY_ON_TXT_EVENT, 
			1.0, SbCSS.BOX_EVENT_BOTTOM,	YMSB_VIRT, moveBoxBottom,	ANI_DELY_ON_BOX_EVENT);
		this.currState		= YMSB_OFF;
		this.currData		= "";
	}

	// データ切り分け
	checkData() {
		const newState		= jsonData[SbJSON.EVENT_SWITCH];
		const txtNew		= jsonData[SbJSON.EVENT_NAME];
		let eventTop		= cFont.eventTop;
		let eventBottom		= cFont.eventBottom;
		let cssEventTop		= {"top" : eventTop + "px"};
		let cssEventBottom	= this.setEventBottom(eventBottom);

		if		(YMSB_OFF_ON == currScoreBoard) {
			if  (this.EVENT_TOP    == newState) {
				this.eventTop.animeOn(txtNew, "", "", "", cssEventTop, false);
			}
			else if
				(this.EVENT_BOTTOM == newState) {
				this.eventBottom.animeOn(txtNew, "", cssEventBottom, "", cssEventBottom, false);
			}
			else {
				// nop
			}
		}
		else if (YMSB_ON_OFF == currScoreBoard) {
			if  (this.EVENT_TOP    == newState) {
				this.eventTop.animeOff();
			}
			else if
				(this.EVENT_BOTTOM == newState) {
				this.eventBottom.animeOff();
			}
			else {
				// nop
			}
		}
		else if (
			(YMSB_ON == currScoreBoard)
		) {
			if		(this.EVENT_TOP		== this.currState && this.EVENT_OFF == newState) {
				this.eventTop.animeOff();
			}
			else if	(this.EVENT_BOTTOM	== this.currState && this.EVENT_OFF == newState) {
				this.eventBottom.animeOff();
			}
			else if (this.EVENT_TOP		== newState && this.EVENT_OFF == this.currState) {
				this.eventTop.animeOn(txtNew, "", "", "", cssEventTop, false);
			}
			else if (this.EVENT_BOTTOM	== newState && this.EVENT_OFF == this.currState) {
				this.eventBottom.animeOn(txtNew, "", cssEventBottom, "", cssEventBottom, false);
			}
			else if (this.EVENT_TOP		== newState && this.EVENT_BOTTOM	== this.currState) {
				this.eventBottom.animeOff();
				this.eventTop.animeOn(txtNew, "", "", "", cssEventTop, false);
			}
			else if	(this.EVENT_BOTTOM	== newState && this.EVENT_TOP		== this.currState) {
				this.eventTop.animeOff();
				this.eventBottom.animeOn(txtNew, "", cssEventBottom, "", cssEventBottom, false);
			}
			else if (this.EVENT_TOP == newState) {
				this.eventTop.animeUpdate(txtNew, "", "", "", cssEventTop, false);
			}
			else if (this.EVENT_BOTTOM == newState) {
				this.eventBottom.animeUpdate(txtNew, "", cssEventBottom, "", cssEventBottom, false);
			}
			else {
				// nop
			}
		}
		this.currState = newState;
	}

	// イベント下部の位置設定
	setEventBottom(eventBottom){
		let cssProp;
		const newBottom = Number(jsonData[SbJSON.BOTTOM_VIEW]);
		if (cBottom.BOTTOM_OFF != newBottom) {
			let tempNum = jQuery("#BoxBottom").css("height");
			switch(newBottom) {
				case cBottom.BOTTOM_LB:
					tempNum = jQuery("#BoxLBBack").css("height");
					break;
				case cBottom.BOTTOM_NEXT:
					tempNum = jQuery(".BottomNext").css("height");
					break;
				case cBottom.BOTTOM_TEXT:
					tempNum = jQuery("#TxtBottom").css("height");
					break;
				default: // case cBottom.BOTTOM_IMAGE:
					tempNum = jQuery("#BoxBottom").css("height");
					break;
			}
			tempNum = parseInt(tempNum.replace(regex, ""));
			cssProp = {"top" : eventBottom - tempNum + "px"};
		}
		else {
			cssProp = {"top" : eventBottom + "px"};
		}
		return cssProp;
	}

}