// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	長期戦スコア
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

class YmsbAnimeLB {

	lbNames			= new Array(2);
	lbCurrScores	= [];
	lbCurrScore1p	= [];
	lbCurrScore2p	= [];
	lbCurrViewRound	= YMSB_OFF;

	LB_SCORE_NONE	= "0";
	LB_SCORE_WIN_1P	= "1";
	LB_SCORE_WIN_2P	= "2";
	LB_SCORE_DRAW	= "3";

	LB_TYPE_ON		= 0;
	LB_TYPE_UPDATE	= 1;

	updateParamSet	= function(txtRotateY, txtRotateZ, txtScale) {
		return {rotationY:txtRotateY, rotationZ:txtRotateZ, scale:txtScale, opacity:0.0}	};
	updateParamOn	= function(dely, txtCSS, txt, txtColor) {
		return {duration:1.4, opacity:1.0, ease:ANI_EASE_OUT, delay:dely, rotationY:0, scale:1.0, rotationZ:0,
			onStart:YmsbAnime.callBackTextUpdate(txtCSS, txt, {"color": txtColor}) }};
	updateParamOff	= function(dely) {
		return {duration:ANI_DUR_BASE, opacity:0.0, ease:ANI_EASE_IN,  delay:dely}};

	constructor(txtVorh, txtFrom01, txtFrom02, boxFrom) {
		this.lbBoxBack	= new YmsbAnime(
			0.0, "",                YMSB_VIRT, "0px",   "", 
			ANIME_LB_OPACITY, SbCSS.BOX_LB_BACK, YMSB_VIRT, boxFrom, ANI_DELY_ON_BOX_LB);
		this.lbNames[0] = new YmsbAnime(
			1.0, SbCSS.TXT_LB_NAME_1P, txtVorh,   txtFrom01, ANI_DELY_ON_TXT_BOTTOM, 
			0.0, "",                   YMSB_VIRT, "0px",   "");
		this.lbNames[1] = new YmsbAnime(
			1.0, SbCSS.TXT_LB_NAME_2P, txtVorh,   txtFrom02, ANI_DELY_ON_TXT_BOTTOM, 
			0.0, "",                   YMSB_VIRT, "0px",   "");
	}

	// ■■ 表示
	animeOn() {
		const skinNumber	= cSkin.currSkinURL;
		const imgURL		= skinNumber + FILE_BOX_LB_BACK;

		// 背景描画
		this.lbBoxBack.animeOn("", "", "", imgURL, "", false);

		// 名前描画
		for (let i = 0; i < 2; i++) {
			const txtNew		= jsonData[JSON_PLAYER_NAME[i]];
			const txtNow		= jsonData[JSON_PLAYER_NOW[i]];
			this.lbNames[i].animeOn(txtNew, txtNow, "", "", "", false);
		}

		// スコア描画
		this.setLBScores(this.LB_TYPE_ON);
	}

	// ■■ 非表示
	animeOff() {
		this.lbBoxBack.animeOff();
		for (let i = 0; i < 2; i++) {
			this.lbNames[i].animeOff();
			for (let j = 0; j < YMSB_MAX_SETS; j++) {
				const cssID = SbCSS.retNumberID(TYPE_TXT, ID_LB_SCORE, i + 1, j + 1);
				gsap.to (cssID, this.updateParamOff(ANI_DELY_OFF_TXT));
			}
		}
	}

	// ■■ 更新
	animeUpdate() {
		for (let i = 0; i < 2; i++) {
			const txtNew		= jsonData[JSON_PLAYER_NAME[i]];
			const txtNow		= jsonData[JSON_PLAYER_NOW[i]];
			this.lbNames[i].animeUpdate(txtNew, txtNow, "", "", "", false);
		}
		// スコア描画
		this.setLBScores(this.LB_TYPE_UPDATE);
	}

	// ■■ スコア描画
	setLBScores(fUpdate) {
		const viewRound			= jsonData[SbJSON.LB_VIEW_ROUND];
		const arrLBnewScores	= jsonData[SbJSON.LB_SCORES];
		const arrLBnewScore1p	= jsonData[SbJSON.LB_SCORES_1P];
		const arrLBnewScore2p	= jsonData[SbJSON.LB_SCORES_2P];
		const arrLBnewScorePl	= [arrLBnewScore1p, arrLBnewScore2p];

		// 更新チェック
		for (let j = 0; j < YMSB_MAX_SETS; j++) {
			let fRet = true;
			if (this.LB_TYPE_UPDATE == fUpdate) {
				fRet = this.checkLBUpdate(arrLBnewScore1p[j], arrLBnewScore2p[j], viewRound, j);
			}
			if (fRet) {
				let arrNewLBTxt = [];

				switch(String(arrLBnewScores[j])) {
					case this.LB_SCORE_WIN_1P:
						arrNewLBTxt[0] = YMSB_TXT_LB_WIN;
						arrNewLBTxt[1] = YMSB_TXT_LB_LOSE;
						break;
					case this.LB_SCORE_WIN_2P:
						arrNewLBTxt[0] = YMSB_TXT_LB_LOSE;
						arrNewLBTxt[1] = YMSB_TXT_LB_WIN;
						break;
					case this.LB_SCORE_DRAW:
						arrNewLBTxt[0] = YMSB_TXT_LB_DRAW;
						arrNewLBTxt[1] = YMSB_TXT_LB_DRAW;
						break;
					default: // this.LB_SCORE_NONE
						arrNewLBTxt[0] = "";
						arrNewLBTxt[1] = "";
						break;
				}	
	
				for (let i = 0; i < 2; i++) {
					const cssID = SbCSS.retNumberID(TYPE_TXT, ID_LB_SCORE, i + 1, j + 1);
					let txtRotateY	= 0;
					let txtRotateZ	= 0;
					let txtScale	= 0.0;
					let txtColor	= "#888";
					if (arrNewLBTxt[i] == YMSB_TXT_LB_WIN) {
						txtColor	= "#FFF";
						if (viewRound) {
							txtRotateY	= 1800;
							txtScale	= 2.0;
						}
						else {
							txtRotateZ	= 720;
							txtScale	= 10.0;
						}
					}
					if ((viewRound) && (this.LB_SCORE_NONE != arrLBnewScores[j])) {
						arrNewLBTxt[i] = arrLBnewScorePl[i][j];
					}
					gsap.timeline()
						.set(cssID, this.updateParamSet(txtRotateY, txtRotateZ, txtScale))
						.to (cssID, this.updateParamOn(ANI_DELY_ON_TXT_BOTTOM, cssID, arrNewLBTxt[i], txtColor));
				}
			}
		}
		this.lbCurrScores		= arrLBnewScores.concat();
		this.lbCurrScore1p		= arrLBnewScore1p.concat();
		this.lbCurrScore2p		= arrLBnewScore2p.concat();
		this.lbCurrViewRound	= viewRound;
	}

	// 更新チェック
	checkLBUpdate(lbNewScore1p, lbNewScore2p, viewRound, set) {
		let value = true;
		if	(
			(lbNewScore1p === this.lbCurrScore1p[set])
		&&  (lbNewScore2p === this.lbCurrScore2p[set])
		&&  (this.lbCurrViewRound == viewRound)
		) {
			value = false;
		}
		return value;
	}
}
