// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	共通定数/変数
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ スコアボードの表示状態
let currScoreBoard					= YMSB_OFF;
const YMSB_OFF_ON					= 2;
const YMSB_ON_OFF					= 3;

// ■■ 下段表示関連
let currBottomSize					= "";
let newBottomSize					= "";

// ■■ JSONファイル読み出し関連
let jsonData;												// JSONから読みだしたデータ
let currTimeStamp					= 0;					// JSONのタイムスタンプ
let idTimeOut;

// ■■ CSSパラメータの数値以外を読み込む際の条件
const regex = "px";

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	初期処理・表示処理
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ 初期化関数 ■■
window.onload = function() {
	// 勝利アニメーション処理の初期化
	winAnimeInit();

	// 各クラスのインスタンス生成
	initClass();

	// 一定時間でJSONファイルを読み込み続ける
	loadJSON();
}

// ■■ JSONファイル読み込み ■■
const loadJSON = () => {
	idTimeOut = setTimeout(async () => {
		let fError = false;
		let cError = "";

		// Googleスプレッドシートからデータ取得
		if (("" != JSON_WebAPI) && (JSON_Remote)){
			resFetch = await fetch(JSON_WebAPI)
				.then(response => {
					if (!response.ok) {
						throw new Error(response.statusText);
					}
					return response.json();
				})
				.then(data => {
					jsonData = data[0];
				})
				.catch(error => {
					fError = true;
					cError = error;
				});
		}
		// ローカルのJSONファイルからデータ取得
		else {
			const data = await fetch(JSON_FILE);
			jsonData = await data.json();
		}

		if (!fError) {
			jQuery("#TxtErrorCode").text("");

			// データからスコアボードを更新
			checkState();
		}
		else {
			jQuery("#TxtErrorCode").text(cError);
		}

		// 再起
		idTimeOut = loadJSON();

	},HANDLER_TIME)
}

// ■■ 終了関数 ■■
window.onbeforeunload = function() {
	clearTimeout(idTimeOut);
}

// ■■ 各クラスのインスタンス生成 ■■
let cFont;
let cSkin;
let cStage;
let cTeamName;
let cScore; 
let cEvent;
let cLogo;
let cMember;
let cNow;
let cBottom;
let cStinger;
/*
let cSide;
*/
function initClass() {
	cFont 		= new YmsbFont();
	cSkin 		= new YmsbSkin();
	cStage		= new YmsbStageCheck(ANIME_STAGE_TXT, ANIME_STAGE_BOX);
	cTeamName	= new YmsbTeamNameCheck(
		ANIME_TEAM_TXT_VH, ANIME_TEAM_TXT_01, ANIME_TEAM_TXT_02,
		ANIME_TEAM_BOX_VH, ANIME_TEAM_BOX_01, ANIME_TEAM_BOX_02); 
	cScore		= new YmsbScoreCheck(
		ANIME_SCORE_TXT_VH, ANIME_SCORE_TXT_01, ANIME_SCORE_TXT_02, 
		ANIME_SCORE_BOX_VH, ANIME_SCORE_BOX_01, ANIME_SCORE_BOX_02); 
	cEvent		= new YmsbEventCheck(
		ANIME_EVENT_TXT_TOP,	ANIME_EVENT_BOX_TOP,
		ANIME_EVENT_TXT_BOTTOM,	ANIME_EVENT_BOX_BOTTOM);
	cLogo		= new YmsbLogoCheck(
		ANIME_LOGO_BOX_VH, ANIME_LOGO_BOX_01, ANIME_LOGO_BOX_02,
		ANIME_LOGO_BOX_VH, ANIME_LOGO_BOX_01, ANIME_LOGO_BOX_02);
	cMember		= new YmsbMemberCheck(YMSB_OFF);
	cNow		= new YmsbNowCheck(
		ANIME_NOW_TXT_VH, ANIME_NOW_TXT_01, ANIME_NOW_TXT_02, 
		ANIME_NOW_BOX_VH, ANIME_NOW_BOX_01, ANIME_NOW_BOX_02);
	cBottom		= new YmsbBottomCheck(ANIME_BOTTOM_TXT, ANIME_BOTTOM_BOX);
	cStinger 	= new YmsbStingerCheck();
/*
	cSide 		= new YmsbSideCheck(
					ANIME_SIDE_TXT_VH, ANIME_SIDE_TXT_01, ANIME_SIDE_TXT_02,
					ANIME_SIDE_BOX_VH, ANIME_SIDE_BOX_01, ANIME_SIDE_BOX_02); 
*/
}