// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	団体戦メンバーの更新チェック
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

class YmsbMemberCheck extends YmsbCheck {

	arrMemberNum	= [];
	arrMemberName	= [];
	arrMemberLife	= [];
	arrMemberLose	= [];
	arrSideLives	= [];
	arrSideLosers	= [];
	arrMoveSide		= [YMSB_RIGHT, YMSB_LEFT];
	YMSB_LIFE_OFF	= 1;
	YMSB_LIFE_ON	= 2;

	constructor(fixHeight) {
		super();
		this.currHide 			= YMSB_OFF;
		this.currFixHeight		= fixHeight;
		this.currBottomSize		= BOTTOM_SIZE_SHORT;
		this.lifeHeight			= 30;
		this.currMaxLives		= 0;
		for (let i = 0; i < 2; i++) {
			this.arrMemberNum[i]	= 0;
			this.arrMemberName[i]	= [];
			this.arrMemberLife[i]	= [];
			this.arrMemberLose[i]	= [];
			for (let j = 0; j < YMSB_MAX_MEMBER; j++) {
				this.arrMemberName[i][j]	= new YmsbMember(
					1.0, SbCSS.retNumberID("Txt", ID_MEMBER_NAME, i+1, j+1), YMSB_HORI, this.arrMoveSide[i] + ANI_MOVE_BOX_SIDE + "px", ANI_DELY_ON_MEMBER,
					0.7, SbCSS.retNumberID("Box", ID_MEMBER_NAME, i+1, j+1), YMSB_HORI, this.arrMoveSide[i] + ANI_MOVE_BOX_SIDE + "px", ANI_DELY_ON_MEMBER);
				this.arrMemberLife[i][j]	= new YmsbMember( 
					1.0, SbCSS.retNumberID("Txt", ID_MEMBER_LIFE, i+1, j+1), YMSB_HORI, this.arrMoveSide[i] + 0					+ "px", ANI_DELY_ON_MEMBER,
					0.7, SbCSS.retNumberID("Box", ID_MEMBER_LIFE, i+1, j+1), YMSB_HORI, this.arrMoveSide[i] + 0					+ "px", ANI_DELY_ON_MEMBER);
				this.arrMemberLose[i][j]	= false;
			}
		}
	}

	// データ切り分け
	checkData() {
		const newHide 		= jsonData[SbJSON.HIDE_MEMBER];
		const newFixHeight	= jsonData[SbJSON.FIX_MEMBER_HEIGHT];
		const newBottomSize	= jsonData[SbJSON.BOTTOM_SIZE]
		const newMaxLives	= jsonData[SbJSON.MAX_MEMBER_LIVES];
		let newMember		= [];
		let memberHeight	= [];
		let memberTop 		= [];

		let jsonMemberName	= [];
		let jsonMemberBack	= [];
		let jsonMemberLoser	= [];
		let jsonMemberLife	= [];
		let jsonMemberOrder = [];
		for (let i = 0; i < 2; i++) {
			jsonMemberName[i]	= jsonData[JSON_MEMBER_NAME[i]];
			jsonMemberBack[i]	= jsonData[JSON_MEMBER_BACK[i]];
			jsonMemberLoser[i]	= jsonData[JSON_MEMBER_LOSER[i]];
			jsonMemberLife[i]	= jsonData[JSON_MEMBER_LIFE[i]];
			jsonMemberOrder[i]	= jsonData[JSON_MEMBER_ORDER[i]];
		}

		// memo
		// 団体戦ライフ０かつライフ連動の場合は相手Dead数をポイント表示させる
		// メンバ変数でSidePointを定義、ローカル変数SideDeadでDead数をカウントし、ループ後に入れ替える

		// メンバー数と枠の高さを設定
		for (let i = 0; i < 2; i++) {
			newMember[i]			= 0;
			this.arrSideLives[i]	= 0;
			this.arrSideLosers[i]	= 0;
			let flagMaxMember = YMSB_OFF;

			// メンバー数・残メンバー・残ライフチェック
			for (let j = YMSB_MAX_MEMBER - 1; j >= 0 ; j--) {

				if ("" != jsonMemberName[i][j]) {
					if (YMSB_ON != flagMaxMember) {
						flagMaxMember = YMSB_ON;
						newMember[i] = j + 1;
					}
				}
			}
			if (0 < newMember[i]) {
				if (YMSB_OFF != newFixHeight && newMember[i] <= YMSB_MAX_FIX_MEMBER) {
					memberHeight[i] = YMSB_FIX_MEMBER_HEIGHT;
					memberTop[i]	= memberHeight[i] + ((arrBottomSize[newBottomSize][BOTTOM_SIZE_MAX_HEIGHT] - 
										(YMSB_FIX_MEMBER_HEIGHT * newMember[i])) / (newMember[i] - 1));
					// 高さ + (全体 - (高さ*人数) / (人数 - 1))
				}
				else if (newMember[i] <= YMSB_MAX_FIX_MEMBER) {
					memberHeight[i] = YMSB_FIX_MEMBER_HEIGHT;
					memberTop[i]	= memberHeight[i];
				}
				else {
					memberHeight[i] = arrBottomSize[newBottomSize][BOTTOM_SIZE_MAX_HEIGHT] / newMember[i];
					memberTop[i]	= memberHeight[i];
				}
			}
		}

		for (let i = 0; i < 2; i++) {
			let newOrder = jsonMemberOrder[i] - 1;

			for (let j = 0; j < YMSB_MAX_MEMBER; j++) {
				let txtNew		= jsonMemberName[i][j];
				let txtLife		= jsonMemberLife[i][j];
				let chkLoser	= jsonMemberLoser[i][j];
				let imgURL		= "";
				if ((jsonMemberBack[i].length > j) && (newMember[i] <= YMSB_MAX_FIX_MEMBER)){
					imgURL	= jsonMemberBack[i][j];
				}
				if (newOrder == j) {
					chkLoser = YMSB_NOW_PLAYING;	
				}
				else if ("0" == txtLife && YMSB_OFF != newMaxLives) {
					chkLoser = YMSB_ON;
				}
				else {
					// nop
				}

				// メンバー表示
				let cssPropTxtName	= "";
				let cssPropBoxName	= "";
				let cssPropTxtLife	= "";
				let cssPropBoxLife	= "";

				if ("" != txtNew) {
					cssPropTxtName	= this.setCssPropTxtName(chkLoser, i, j, memberHeight[i], memberTop[i], imgURL);
					cssPropBoxName	= this.setCssPropBoxName(chkLoser, i, j, memberHeight[i], memberTop[i], imgURL);
					cssPropTxtLife	= this.setCssPropTxtLife(chkLoser, j,    memberTop[i]);
					cssPropBoxLife	= this.setCssPropBoxLife(chkLoser, i, j, memberTop[i]);
				}
				else {
					txtLife = "";
					imgURL  = "";
				}

				if (
					(YMSB_OFF_ON == currScoreBoard && YMSB_OFF == newHide)
				||  (YMSB_ON     == currScoreBoard && YMSB_ON  == this.currHide && YMSB_OFF == newHide)
				) {
					this.arrMemberName[i][j].animeOn(txtNew,  "", cssPropTxtName, "", cssPropBoxName, false);
					if (this.YMSB_LIFE_OFF < newMaxLives) {
						this.arrMemberLife[i][j].animeOn(txtLife, "", cssPropTxtLife, "", cssPropBoxLife, false);
					}
				}
				else if (
					(YMSB_ON_OFF == currScoreBoard && YMSB_OFF == this.currHide)
				||  (YMSB_ON     == currScoreBoard && YMSB_OFF == this.currHide && YMSB_ON  == newHide)
				) {
					this.arrMemberName[i][j].animeOff();
					if (this.YMSB_LIFE_OFF < this.currMaxLives) {
						this.arrMemberLife[i][j].animeOff();
					}
				}
				else if (
					(YMSB_ON == currScoreBoard && YMSB_OFF == this.currHide && YMSB_OFF == newHide)
				) {
					this.arrMemberName[i][j].animeUpdate(txtNew,  "", cssPropTxtName, "", cssPropBoxName, false, ANI_CHANGE_TYPE_COLOR);
					if (	(this.YMSB_LIFE_OFF <  newMaxLives) && (this.YMSB_LIFE_OFF <  this.currMaxLives)) {
						this.arrMemberLife[i][j].animeUpdate(txtLife, "", cssPropTxtLife, "", cssPropBoxLife, false, ANI_CHANGE_TYPE_ROLL_Y);
					}
					else if((this.YMSB_LIFE_OFF <  newMaxLives) && (this.YMSB_LIFE_OFF >= this.currMaxLives)) {
						this.arrMemberLife[i][j].animeOn(txtLife, "", cssPropTxtLife, "", cssPropBoxLife, false);
					}
					else if((this.YMSB_LIFE_OFF >= newMaxLives) && (this.YMSB_LIFE_OFF <  this.currMaxLives)) {
						this.arrMemberLife[i][j].animeOff();
					}
					else {
						// nop
					}
				}
				else {
					// nop
				}
				this.arrMemberLose[i][j]	= chkLoser;
			}
			this.arrMemberNum[i] = newMember[i];
		}
		this.currFixHeight 	= newFixHeight;
		this.currHide 		= newHide;
		this.currBottomSize = newBottomSize;
		this.currMaxLives	= newMaxLives;
	}

	// CSSプロパティ設定（テキスト）
	setCssPropTxtName(chkLoser, side, member, memberHeight, memberTop, imgURL) {
		const arrJustify = ["end", "start"];
		let fontColor;
		let fontShadow = "1px 1px 2px ";
		if (YMSB_ON == chkLoser){
			fontColor  = cSkin.COLOR_TXT_MEMBER_LOS;
			fontShadow += cSkin.SHADE_TXT_MEMBER_LOS;
		}
		else if (YMSB_NOW_PLAYING == chkLoser){
			fontColor  = cSkin.COLOR_TXT_MEMBER_WIN;
			fontShadow += cSkin.SHADE_TXT_MEMBER_NOW;
		}
		else {
			fontColor  = cSkin.COLOR_TXT_MEMBER_WIN;
			fontShadow += cSkin.SHADE_TXT_MEMBER_WIN;
		}

		let alighItems		= "center";
		let justifyContent	= "center";
		if ("" != imgURL) {
			alighItems		= "end";
			justifyContent	= arrJustify[side];
		}

		let cssPropTxt = {
			"top"				: YMSB_MEMBER_POSITION_TOP + member * memberTop,
			"height"			: memberHeight - 5,
			"color"				: fontColor,
			"text-shadow"		: fontShadow,
			"align-items"		: alighItems,
			"justify-content"	: justifyContent
		};
		return cssPropTxt;
	}
	setCssPropTxtLife(chkLoser, member, memberTop) {
		let fontColor;
		let fontShadow = "1px 1px 3px ";
		if (YMSB_ON == chkLoser){
			fontColor	= cSkin.COLOR_TXT_MEMBER_LOS;
			fontShadow += cSkin.SHADE_TXT_MEMBER_LOS;
		}
		else if (YMSB_NOW_PLAYING == chkLoser){
			fontColor	= cSkin.COLOR_TXT_MEMBER_WIN;
			fontShadow += cSkin.SHADE_TXT_MEMBER_WIN;
		}
		else {
			fontColor	= cSkin.COLOR_TXT_MEMBER_WIN;
			fontShadow += cSkin.SHADE_TXT_MEMBER_WIN;
		}

		let cssPropTxt = {
			"top"			: YMSB_MEMBER_POSITION_TOP + member * memberTop,
			"height"		: this.lifeHeight,
			"color"			: fontColor,
			"text-shadow"	: fontShadow
		};
		return cssPropTxt;
	}

	// CSSプロパティ設定（背景）
	setCssPropBoxName(chkLoser, side, member, memberHeight, memberTop, imgURL) {
		const currSkin = cSkin.currSkin;
		let bgColor		= arrSkins[cSkin.arrColorMemberBox[side][cSkin.COLOR_BOX]][currSkin];
		let bgBorder	= arrSkins[cSkin.arrColorMemberBox[side][cSkin.COLOR_BORDER]][currSkin];;
		let bgBlend		= "normal";
		if (YMSB_ON == chkLoser){
			bgColor		= cSkin.COLOR_MEMBER_BACK_LOS;
			bgBlend		= "luminosity";
		}
		else if (YMSB_NOW_PLAYING == chkLoser){
			bgBorder	= arrSkins[cSkin.arrColorMemberBox[side][cSkin.COLOR_NOW]][currSkin];
			bgColor		= bgBorder;
		}
		else {
			// nop
		}

		if ("" != imgURL) {
			imgURL = YMSB_URL_USER + imgURL + YMSB_IMAGE_EXT;
		}

		let cssPropBox = {
			"top"				: YMSB_MEMBER_POSITION_TOP + member * memberTop,
			"height"			: memberHeight - 5,
			"background-color"	: bgColor,
			"background-image"	: "url(" + imgURL  + ")",
			"background-blend-mode" : bgBlend,
			"border-color"		: bgBorder,
		};
		return cssPropBox;
	}

	setCssPropBoxLife(chkLoser, side, member, memberTop) {
		const currSkin	= cSkin.currSkin;
		let bgColor		= arrSkins[cSkin.arrColorMemberBox[side][cSkin.COLOR_BOX]][currSkin];
		if (YMSB_ON == chkLoser){
			bgColor    = cSkin.COLOR_MEMBER_BACK_LOS;
		}

		let cssPropBox = {
			"top"				: YMSB_MEMBER_POSITION_TOP + member * memberTop,
			"height"			: this.lifeHeight,
			"background-color"	: bgColor,
		};
		return cssPropBox;
	}
}