// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	フォント・スキンクラス
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// コンストラクタで利用（thisを付けるほど重要でもない）
let tempNum;
let index;

// 団体戦の対戦中メンバー
const YMSB_NOW_PLAYING				= 2;

// ■■ フォント設定 ■■
class YmsbFont {

	FONT_NAME				= 0;
	FONT_TOP_STAGE			= 1;
	FONT_TOP_TEAM			= 2;
	FONT_TOP_SCORE			= 3;
	FONT_TOP_NOW			= 4;
	FONT_TOP_STAR			= 5;
	FONT_TOP_EVENT			= 6;
	FONT_TOP_LB_TOP			= 7;
	FONT_DEFAULT			= 99;
	arrTopX					= [SbCSS.TXT_STAGE, SbCSS.TXT_TEAM, SbCSS.TXT_SCORE, SbCSS.TXT_NOW, SbCSS.TXT_STAR];
	arrTopY					= [SbCSS.TXT_EVENT_TOP, SbCSS.TXT_EVENT_BOTTOM, SbCSS.TXT_LB_TOP, SbCSS.TXT_LB_BOTTOM];
	arrCurrTopX				= new Array(this.arrTopX.length);
	arrCurrTopY				= new Array(this.arrTopY.length);
	currFontNumber;

	constructor() {
		this.currFontNumber = this.FONT_DEFAULT;
		// CSSで定義されている各TOPを取得
		this.arrTopX.forEach((element, index) => {
			tempNum = jQuery(element).css("top");
			tempNum = tempNum.replace(regex, "");
			this.arrCurrTopX[index] = parseInt(tempNum);
		  });
		this.arrTopY.forEach((element, index) => {
			tempNum = jQuery(element).css("top");
			tempNum = tempNum.replace(regex, "");
			this.arrCurrTopY[index] = parseInt(tempNum);
		  });
	}

	get currFont() {
		return this.currFontNumber;
	}

	setDefaultFont() {
		this.currFontNumber = this.FONT_DEFAULT;
	}

	get eventTop() {
		return this.arrCurrTopY[0];
	}

	get eventBottom() {
		return this.arrCurrTopY[1];
	}

	checkData() {
		let newFont = jsonData[SbJSON.FONT];
		if (this.currFontNumber != newFont) {
			jQuery("body").css({"font-family":arrFonts[this.FONT_NAME][newFont]});

			// フォント変更による位置の微調整
			this.arrTopX.forEach((element, index) => {
				let fontIndex = index + 1;
				tempNum = this.arrCurrTopX[index] + arrFonts[fontIndex][newFont];
				tempNum = tempNum + "px";
				jQuery(element).css({"top" : tempNum});
			});
			this.arrTopY.forEach((element, index) => {
				let fontIndex = this.FONT_TOP_EVENT + Math.floor(index / 2);
				tempNum = this.arrCurrTopY[index] + arrFonts[fontIndex][newFont];
				tempNum = tempNum + "px";
				jQuery(element).css({"top" : tempNum});
			});
			this.currFontNumber = newFont;
		}
	}
}

const FILE_BOX_BACK				= "BoxBack.png";
const FILE_BOX_STAGE			= "BoxStage.png";
const FILE_BOX_EVENT			= "BoxEvent.png";
const FILE_BOX_LB_BACK			= "BoxLBBack.png";
const FILE_BOX_STINGER_BACK		= "BoxStingerBack.png";
const FILE_BOX_STINGER_WINDOW	= "BoxStingerWindow.png";
const FILE_BOX_TEAM				= ["BoxTeam1p.png", 	"BoxTeam2p.png"];
const FILE_BOX_SCORE			= ["BoxScore1p.png", 	"BoxScore2p.png"];
const FILE_BOX_NOW				= ["BoxNow1p.png", 		"BoxNow2p.png"];
const FILE_BOX_STAR				= ["BoxStar1p.png", 	"BoxStar2p.png"];
const FILE_BOX_COMMENT			= ["BoxComment1p.png", 	"BoxComment2p.png"];

// ■■ スキン設定 ■■
class YmsbSkin {

		SKIN_NUMBER					=  0;
		COLOR_BODY_TXT				=  1;
		COLOR_BODY_SHADE			=  2;
		COLOR_STAGE_TXT				=  3;
		COLOR_STAGE_SHADE			=  4;
		COLOR_TEAM_TXT_1P			=  5;
		COLOR_TEAM_SHADE_1P			=  6;
		COLOR_TEAM_TXT_2P			=  7;
		COLOR_TEAM_SHADE_2P			=  8;
		COLOR_SCORE_TXT_1P			=  9;
		COLOR_SCORE_SHADE_1P		= 10;
		COLOR_SCORE_TXT_2P			= 11;
		COLOR_SCORE_SHADE_2P		= 12;
		COLOR_MEMBER_BOX_1P			= 13;
		COLOR_MEMBER_NOW_1P			= 14;
		COLOR_MEMBER_BORDER_1P		= 15;
		COLOR_MEMBER_BOX_2P			= 16;
		COLOR_MEMBER_NOW_2P			= 17;
		COLOR_MEMBER_BORDER_2P		= 18;

		/// 団体戦メンバー文字色/影色
		COLOR_TXT_MEMBER_WIN		= "#eee";	
		SHADE_TXT_MEMBER_WIN		= "#000";
		COLOR_TXT_MEMBER_LOS		= "#222";	
		SHADE_TXT_MEMBER_LOS		= "#FFF";
		COLOR_TXT_MEMBER_NOW		= this.COLOR_TXT_MEMBER_WIN;	
		SHADE_TXT_MEMBER_NOW		= "#660";

		COLOR_MEMBER_BORDER_NOW		= "#F33";		// 団体戦メンバーの枠色　（プレイ中）
		COLOR_MEMBER_BACK_LOS		= "#000";		// 団体戦メンバーの背景色（敗退）
		
		PARAM_BORDER_SIDE			= "10px solid ";
		PARAM_BORDER_BOTTOM			= "0px solid ";
//		PARAM_FONTSHADE				= "5px 5px 3px ";
		PARAM_FONTSHADE				= "2px 2px 2px ";
// 		PARAM_FONTSHADE				= "2px 2px 0px #000, -2px 2px 0px #000, 2px -2px 0px #000, -2px -2px 0px ";

		COLOR_TXT					= 0;
		COLOR_SHADE					= 1;
		COLOR_BOX					= 0;
		COLOR_NOW					= 1;
		COLOR_BORDER				= 2;

		arrColorTeamTxt				= [	[this.COLOR_TEAM_TXT_1P,	this.COLOR_TEAM_SHADE_1P],
										[this.COLOR_TEAM_TXT_2P,	this.COLOR_TEAM_SHADE_2P]];
		arrColorScoreTxt			= [	[this.COLOR_SCORE_TXT_1P,	this.COLOR_SCORE_SHADE_1P],
										[this.COLOR_SCORE_TXT_2P,	this.COLOR_SCORE_SHADE_2P]];
		arrColorMemberBox			= [	[this.COLOR_MEMBER_BOX_1P,	this.COLOR_MEMBER_NOW_1P,	this.COLOR_MEMBER_BORDER_1P],
										[this.COLOR_MEMBER_BOX_2P,	this.COLOR_MEMBER_NOW_2P,	this.COLOR_MEMBER_BORDER_2P]];

	constructor() {
		this.currSkinNumber		= this.SKIN_DEFAULT;
		this.currStingerBack	= "";
		this.currStingerWindow	= "";
		this.skinURL			= "";
	}

	get defStingerBack() {
		return this.currStingerBack;
	}

	get defStingerWindow() {
		return this.currStingerWindow;
	}

	get currSkin() {
		return this.currSkinNumber;
	}

	get currSkinURL() {
		return this.skinURL;
	}

	setDefaultSkin() {
		this.currSkinNumber = this.SKIN_DEFAULT;
	}

	checkData() {
		let newSkin	= jsonData[SbJSON.SKIN];
		if (this.currSkinNumber != newSkin) {
			// 画像ファイル更新
			let skinNumber		= YMSB_URL_IMG + arrSkins[this.SKIN_NUMBER][newSkin];
			let retFileSingle	= function(fileName) {return skinNumber + fileName};
			let retFileSide		= function(id, side) {return skinNumber + TYPE_BOX + id + side + "p" + YMSB_IMAGE_EXT};
			const arrIDSide		= [ID_TEAM, ID_SCORE, ID_NOW, ID_STAR, ID_COMMENT];
			jQuery(SbCSS.BOX_BACK 			).attr("src", retFileSingle(FILE_BOX_BACK));
			jQuery(SbCSS.BOX_STAGE			).attr("src", retFileSingle(FILE_BOX_STAGE));
			jQuery(SbCSS.BOX_EVENT_TOP		).attr("src", retFileSingle(FILE_BOX_EVENT));
			jQuery(SbCSS.BOX_EVENT_BOTTOM	).attr("src", retFileSingle(FILE_BOX_EVENT));
			jQuery(SbCSS.BOX_LB_BACK		).attr("src", retFileSingle(FILE_BOX_LB_BACK));
			arrIDSide.forEach((element) => {
				for (let side = 1; side <= 2; side++) {
					jQuery(SbCSS.retID(TYPE_BOX, element, side)).attr("src", retFileSide(element, side));
				}
			});

			// スティンガーのデフォルト設定
			this.currStingerBack	= skinNumber + FILE_BOX_STINGER_BACK;
			this.currStingerWindow	= skinNumber + FILE_BOX_STINGER_WINDOW;
			jQuery(SbCSS.BOX_BACK_STINGER_DEF	).attr("src" , this.currStingerBack);
			jQuery(SbCSS.BOX_STINGER_WINDOW		).css("background-image" , "url(" + this.currStingerWindow	+ ")");
			jQuery(SbCSS.TXT_STINGER_VS			).text(YmsbAnime.fitTextWidth(YMSB_TXT_VS, SbCSS.TXT_STINGER_VS));
			jQuery(SbCSS.TXT_STINGER_NEXT_CENTER).text(YmsbAnime.fitTextWidth(YMSB_TXT_STINGER_NEXT_CENTER, SbCSS.TXT_STINGER_NEXT_CENTER));

			// CSS更新
			jQuery(SbCSS.TXT_STAGE).css  ({"color"           : 							arrSkins[this.COLOR_STAGE_TXT  ][newSkin],
										   "text-shadow"     : this.PARAM_FONTSHADE + 	arrSkins[this.COLOR_STAGE_SHADE][newSkin]});
			jQuery(SbCSS.TXT_EVENT).css  ({"color"           : 							arrSkins[this.COLOR_STAGE_TXT  ][newSkin],
										   "text-shadow"     : this.PARAM_FONTSHADE + 	arrSkins[this.COLOR_STAGE_SHADE][newSkin]});

			const newMaxLives		= jsonData[SbJSON.MAX_MEMBER_LIVES];
			for (let i = 0; i < 2; i++) {
				const borderParamSide   = this.PARAM_BORDER_SIDE   + arrSkins[this.arrColorMemberBox[i][this.COLOR_BORDER]][newSkin];
				const borderParamBottom = this.PARAM_BORDER_BOTTOM + arrSkins[this.arrColorMemberBox[i][this.COLOR_BORDER]][newSkin];
				const memberName	= jsonData[JSON_MEMBER_NAME[i]];
				const memberOrder	= jsonData[JSON_MEMBER_ORDER[i]] + 1;	// ０：チームの別名、１～：メンバー
				const memberLoser	= jsonData[JSON_MEMBER_LOSER[i]];
				const memberLife	= jsonData[JSON_MEMBER_LIFE[i]];
				const memberColor	= arrSkins[this.arrColorMemberBox[i][this.COLOR_BOX]][newSkin];
				const memberShade	= arrSkins[this.arrColorMemberBox[i][this.COLOR_BORDER]][newSkin];
				const side			= i + 1;
				for (let j = 0; j < YMSB_MAX_MEMBER; j++) {
					if ("" != memberName[j]) {
						let mLoser		= memberLoser[j];
						let newLife		= memberLife[j];

						if (memberOrder == j) {
							mLoser = YMSB_NOW_PLAYING;	
						}
						else if (0 == newLife && 0 != newMaxLives) {
							mLoser = YMSB_ON;
						}
						else {
							// nop
						}
						let borderParamMemberSide = borderParamSide;
						let backParamMember = memberColor;

						if (YMSB_ON == mLoser) {
							backParamMember = this.COLOR_MEMBER_BACK_LOS;
						}
						else if (YMSB_NOW_PLAYING == mLoser) {
							borderParamMemberSide = this.PARAM_BORDER_SIDE + this.COLOR_MEMBER_BORDER_NOW;
						}
						else {
							// nop
						}
						jQuery(SbCSS.retNumberID(TYPE_BOX, ID_MEMBER_NAME, side, j)).css({
							"background-color":backParamMember,
							"border-bottom": borderParamBottom,
							"border-left"  : borderParamMemberSide,
							"border-right" : borderParamMemberSide,
							});
						jQuery(SbCSS.retNumberID(TYPE_BOX, ID_MEMBER_LIFE, side, j)).css({
							"background-color":backParamMember,
							"border": borderParamBottom,
						});
					}
				}
				jQuery(SbCSS.retID(TYPE_TXT, ID_TEAM, side) ).css({
											"color"           : 						arrSkins[this.arrColorTeamTxt[i][this.COLOR_TXT]][newSkin],
											"text-shadow"     : this.PARAM_FONTSHADE +	arrSkins[this.arrColorTeamTxt[i][this.COLOR_SHADE]][newSkin]});
				jQuery(SbCSS.retID(TYPE_TXT, ID_NOW, side)).css  ({
											"color"           : 						arrSkins[this.arrColorTeamTxt[i][this.COLOR_TXT]][newSkin],
											"text-shadow"     : this.PARAM_FONTSHADE +	arrSkins[this.arrColorTeamTxt[i][this.COLOR_SHADE]][newSkin]});
				jQuery(SbCSS.retID(TYPE_TXT, ID_SCORE, side)).css({
											"color"           : 						arrSkins[this.arrColorScoreTxt[i][this.COLOR_TXT]][newSkin],
											"text-shadow"     : this.PARAM_FONTSHADE +	arrSkins[this.arrColorScoreTxt[i][this.COLOR_SHADE]][newSkin]});
				jQuery(SbCSS.retID(TYPE_TXT, ID_STAR, side)).css({
											"color"           : 						arrSkins[this.arrColorScoreTxt[i][this.COLOR_TXT]][newSkin],
											"text-shadow"     : this.PARAM_FONTSHADE +	arrSkins[this.arrColorScoreTxt[i][this.COLOR_SHADE]][newSkin]});
				jQuery(SbCSS.retID(TYPE_TXT, ID_STINGER_NEXT, side)).css({		// スティンガー次戦カードの名前。団体戦メンバーのBOXと同じ色にする
											"color"           : memberColor,
											"text-stroke"     : this.BORDER_SIZE_NEXT + memberShade});
				jQuery(SbCSS.retID(TYPE_TXT, ID_NEXT, side)).css({
											"background-color": memberColor,
											"border-bottom"   : borderParamBottom,
											"border-left"     : borderParamSide,
											"border-right"    : borderParamSide});

			}
			this.currSkinNumber	= newSkin;
			this.skinURL		= skinNumber;
		}
	}
}
