// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	画面更新処理
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ スコアボードの状態チェック ■■
function checkState() {
	const newTimeStamp  = jsonData[SbJSON.TIMESTAMP];
	const newScoreBoard = jsonData[SbJSON.MAIN_ANIMATION];
	newBottomSize		= jsonData[SbJSON.BOTTOM_SIZE];
	JSON_Remote			= jsonData[SbJSON.REMOTE_SWITCH];
	const remoteWebAPI	= jsonData[SbJSON.REMOTE_WEBAPI];

	// リモート/ローカル変更時はフラグを立て、データ更新は行わない
	if (
		(YMSB_ON == JSON_Remote)
	&&	(""	!= remoteWebAPI) && ("this" != remoteWebAPI)
	) {
		JSON_WebAPI = remoteWebAPI;
		currTimeStamp = 0;
		cFont.setDefaultFont();
		cSkin.setDefaultSkin();
		return;
	}
	else if (
		(YMSB_ON != JSON_Remote)
	&&	("this" == remoteWebAPI)
	) {
		JSON_WebAPI = "";
		currTimeStamp = 0;
		cFont.setDefaultFont();
		cSkin.setDefaultSkin();
		return;
	}
	else {
		// nop
	}

	// スコアボードの状態遷移確認
	if		((YMSB_OFF == currScoreBoard) && (YMSB_ON  == newScoreBoard)) {
		currScoreBoard = YMSB_OFF_ON;
	}
	else if ((YMSB_ON  == currScoreBoard) && (YMSB_OFF == newScoreBoard)) {
		currScoreBoard = YMSB_ON_OFF
	}
	else {
		// nop
	}

	// 更新処理
	if (newTimeStamp == currTimeStamp) {
		// nop
	}
	else {
		checkData();
	}

	// スコアボードの状態を修正
	if	(YMSB_OFF_ON == currScoreBoard) {
		currScoreBoard = YMSB_ON;
	}
	else if
		(YMSB_ON_OFF == currScoreBoard) {
		currScoreBoard = YMSB_OFF;
	}
	else {
		currScoreBoard = newScoreBoard;
	}
	currTimeStamp = newTimeStamp;
	currBottomSize = newBottomSize;
}

// ■■ 更新処理 ■■
function checkData() {
	cFont.checkData();
	cSkin.checkData();
	const isAniUpdateStage	= cStage.checkData();
	const isAniUpdateTeam	= cTeamName.checkData();
	cScore.checkData();
	cEvent.checkData();
	cLogo.checkData();
	cMember.checkData();
	cNow.checkData();
	const isAniUpdateBottom	= cBottom.checkData();
	cStinger.checkData();
	winAnime();
/*
	if (YMSB_ON == ANIME_SIDE) {
		cSide.checkData();
	}
*/
	if ((isAniUpdateStage) || (isAniUpdateTeam) || (isAniUpdateBottom)) {
		cStage.animeRestart();
		cTeamName.animeRestart();
		cBottom.animeRestart();
	}
}
