// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	スティンガーアニメーション関連
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// スティンガーアニメーションの種類
const STINGER_TYPE_RANDOM				= 0;
const STINGER_TYPE_FADE					= 1;
const STINGER_TYPE_BLUR					= 2;
const STINGER_TYPE_CLOSE_01				= 3;
const STINGER_TYPE_CLOSE_02				= 4;
const STINGER_TYPE_CLOSE_03				= 5;
const STINGER_TYPE_CLOSE_04				= 6;
const STINGER_TYPE_RANDOM_START			= STINGER_TYPE_RANDOM + 1;
const STINGER_TYPE_RANDOM_END			= STINGER_TYPE_CLOSE_04 + 1;

const STINGER_TEXT_TYPE_RANDOM			= 0;
const STINGER_TEXT_TYPE_ZOOM_OUT		= 1;
const STINGER_TEXT_TYPE_POP				= 2;
const STINGER_TEXT_TYPE_DROP			= 3;
const STINGER_TEXT_TYPE_RANDOM_START	= STINGER_TEXT_TYPE_RANDOM + 1;
const STINGER_TEXT_TYPE_RANDOM_END		= STINGER_TEXT_TYPE_DROP + 1;

const STINGER_TEXT_NONE					= 0;
const STINGER_TEXT_NAME					= 1;
const STINGER_TEXT_EVENT				= 2;

const STINGER_BG_GAME					= 0;
const STINGER_BG_IMAGE					= 1;
const STINGER_BG_NEXT_BATTLE			= 2;
const STINGER_BG_COMMENT_TEAM			= 3;
const STINGER_BG_COMMENT_PLAYER			= 4;

const STINGER_USER_IMAGE_WINDOW			= 0;
const STINGER_USER_IMAGE_BACK			= 1;

const STINGER_BACK_BLUR_OFF				= "grayscale(0%) blur(0px)";
const STINGER_BACK_BLUR_ON				= "grayscale(90%) blur(10px)";

const ANI_COMP_BOX_STINGER				= 1.0;		// スティンガー背景
const ANI_COMP_BOX_BACK_CENTER			= 0.5;		// 中央背景
const ANI_DELY_BOX_BACK_CENTER			= 0.5;


class YmsbStingerCheck extends YmsbCheck {

	constructor() {
		super();
		this.currStingerState	= STINGER_BG_GAME;
		this.currUserWindow		= "";
		this.currUserBack		= "";
	}

	// データ切り分け
	checkData() {
		const newStingerState = jsonData[SbJSON.STINGER];

		// ユーザ指定の画像チェック
		let setData = "";
		const userWindow = jsonData[SbJSON.STINGER_WINDOW];
		if (this.currUserWindow != userWindow){
			if ("" != userWindow)	{setData = YMSB_URL_USER + decodeURI(userWindow) + ".png";}
			else					{setData = cSkin.defStingerWindow;}
			jQuery(SbCSS.BOX_STINGER_WINDOW).css("background-image", "url(" + setData + ")");
		}
		this.currUserWindow = userWindow;

		const userBack = jsonData[SbJSON.STINGER_IMAGE];
		if (this.currUserBack != userBack) {
			if ("" != userBack)		{setData = YMSB_URL_USER + decodeURI(userBack) + ".png";}
			else					{setData = cSkin.defStingerBack;}
			jQuery(SbCSS.BOX_BACK_STINGER_DEF).attr("src", setData);
		}
		this.currUserBack = userBack;

		if (this.currStingerState != newStingerState) {
			this.exStingerWindow();
			this.exStingerText(newStingerState);
			this.setStingerBack(newStingerState);
		}

		this.currStingerState = newStingerState;
	}

	// スティンガー実行（窓）
	exStingerWindow() {
		let stingerType = Number(jsonData[SbJSON.STINGER_TYPE]);
		let paramDef = function(op) {
			return {scale: 1.0, x: "0px", y: "0px", opacity: op, webkitFilter: "blur(0px)",
			transformPerspective: 1080, transformOrigin: "50% 50%", rotationY: 0, rotationX: 0}};
		let paramStart;
		let paramMid;
		let paramEnd;
		const ELEM_ROOT	= ":root";
		const P_COLOR_MID = "rgba(255, 255, 255, 0.0)";
		const P_COLOR_DEF = "rgba(255, 255, 255, 1.0)";
		const DURA_BEFORE	= 0.5;
		const DURA_AFTER	= 0.5;
		const SW_GAP		= "+=1.0";
		const SW_FULL		= SbCSS.BOX_STINGER_WINDOW_ALL;
		const SW_VIRT_2		= [	SbCSS.BOX_STINGER_WINDOW_V2_1, SbCSS.BOX_STINGER_WINDOW_V2_2];
		const SW_VIRT_4		= [	SbCSS.BOX_STINGER_WINDOW_V4_1, SbCSS.BOX_STINGER_WINDOW_V4_2, SbCSS.BOX_STINGER_WINDOW_V4_3, SbCSS.BOX_STINGER_WINDOW_V4_4];
		const SW_VIRT_8		= [	SbCSS.BOX_STINGER_WINDOW_V8_1, SbCSS.BOX_STINGER_WINDOW_V8_2, SbCSS.BOX_STINGER_WINDOW_V8_3, SbCSS.BOX_STINGER_WINDOW_V8_4
							  ,	SbCSS.BOX_STINGER_WINDOW_V8_5, SbCSS.BOX_STINGER_WINDOW_V8_6, SbCSS.BOX_STINGER_WINDOW_V8_7, SbCSS.BOX_STINGER_WINDOW_V8_8];
		const SW_HORI_2		= [	SbCSS.BOX_STINGER_WINDOW_H2_1, SbCSS.BOX_STINGER_WINDOW_H2_2];
		const SW_HORI_4		= [	SbCSS.BOX_STINGER_WINDOW_H4_1, SbCSS.BOX_STINGER_WINDOW_H4_2, SbCSS.BOX_STINGER_WINDOW_H4_3, SbCSS.BOX_STINGER_WINDOW_H4_4];
		const SW_HORI_8		= [	SbCSS.BOX_STINGER_WINDOW_H8_1, SbCSS.BOX_STINGER_WINDOW_H8_2, SbCSS.BOX_STINGER_WINDOW_H8_3, SbCSS.BOX_STINGER_WINDOW_H8_4
							  ,	SbCSS.BOX_STINGER_WINDOW_H8_5, SbCSS.BOX_STINGER_WINDOW_H8_6, SbCSS.BOX_STINGER_WINDOW_H8_7, SbCSS.BOX_STINGER_WINDOW_H8_8];
		const pColorMid		= [	{ duration: 0.5, "--bg-color01" : P_COLOR_MID }
							,	{ duration: 0.5, "--bg-color02" : P_COLOR_MID }
							,	{ duration: 0.5, "--bg-color03" : P_COLOR_MID }
							,	{ duration: 0.5, "--bg-color04" : P_COLOR_MID }
							,	{ duration: 0.5, "--bg-color05" : P_COLOR_MID }
							,	{ duration: 0.5, "--bg-color06" : P_COLOR_MID }
							,	{ duration: 0.5, "--bg-color07" : P_COLOR_MID }
							,	{ duration: 0.5, "--bg-color08" : P_COLOR_MID }];
		const pColorEnd		= [	{ duration: 0.5, "--bg-color01" : P_COLOR_DEF }
							,	{ duration: 0.5, "--bg-color02" : P_COLOR_DEF }
							,	{ duration: 0.5, "--bg-color03" : P_COLOR_DEF }
							,	{ duration: 0.5, "--bg-color04" : P_COLOR_DEF }
							,	{ duration: 0.5, "--bg-color05" : P_COLOR_DEF }
							,	{ duration: 0.5, "--bg-color06" : P_COLOR_DEF }
							,	{ duration: 0.5, "--bg-color07" : P_COLOR_DEF }
							,	{ duration: 0.5, "--bg-color08" : P_COLOR_DEF }];

		if (STINGER_TYPE_RANDOM == stingerType) {
			stingerType = Math.floor(Math.random() * (STINGER_TYPE_RANDOM_END - STINGER_TYPE_RANDOM_START)) + STINGER_TYPE_RANDOM_START;
		}

		switch (stingerType) {
			case STINGER_TYPE_FADE:
				gsap.timeline()
					.set(SW_FULL, { scale: 0.99 })
					.to (SW_FULL, { duration: DURA_BEFORE, ease: ANI_EASE_IN, opacity: 1.0, scale: 1.01})
					.to (SW_FULL, { duration: DURA_AFTER,  ease: ANI_EASE_IN, opacity: 0.0, scale: 0.99 }, SW_GAP)
					.set(SW_FULL, paramDef(0.0));
					break;

			case STINGER_TYPE_BLUR:
				gsap.timeline()
					.set(SW_FULL, { webkitFilter: "blur(20px)", scale: 20.0 })
					.to (SW_FULL, { duration: DURA_BEFORE, ease: ANI_EASE_IN,   opacity: 1.0, scale: 1.0,  webkitFilter: "blur(0px)" })
					.to (SW_FULL, { duration: 1.0, ease: ANI_EASE_NONE, scale: 1.01 })
					.to (SW_FULL, { duration: DURA_AFTER,  ease: ANI_EASE_IN,   opacity: 0.0, scale:20.0,  webkitFilter: "blur(20px)"})
					.set(SW_FULL, paramDef(0.0));
				break;
/*
			case STINGER_TYPE_ZOOM_01:
				SW_VIRT_4.forEach(function (element, index) {
					gsap.timeline()
						.set(element,  { scaleX:0.1 })
						.to (element,  { duration: 0.2, ease: ANI_EASE_OUT, opacity: 1.0, scaleX:1.0, delay:index * 0.1 })
						.to (ELEM_ROOT, pColorMid[index])
						.to (element,  { duration: DURA_AFTER,  ease: ANI_EASE_IN, opacity: 0.0 })
						.set(element, paramDef(0.0))
						.set(ELEM_ROOT, pColorEnd[index]);
				});
				break;
*/
			case STINGER_TYPE_CLOSE_01:
/*
				paramStart = [{"backgroundPosition" : 960, opacity: 1.0} , {"backgroundPosition" : -1920, opacity: 1.0}];
				paramMid   = [	{duration: DURA_BEFORE, ease: ANI_BOUNCE_OUT, "backgroundPosition" : 0},
								{duration: DURA_BEFORE, ease: ANI_BOUNCE_OUT, "backgroundPosition" : -960}];
				paramEnd   = [{"backgroundPosition" : 960} , {"backgroundPosition" : -1920}];
				paramReset = [{"backgroundPosition" : 0}   , {"backgroundPosition" : -960}];
*/
				paramStart	= [	{ x: "-960px", opacity: 1.0 }, { x: "960px", opacity: 1.0 }];
				paramEnd	= [
								{ duration: DURA_AFTER, ease: ANI_EASE_IN, x: "-960px" }
							,	{ duration: DURA_AFTER, ease: ANI_EASE_IN, x: "960px" }
							];
				SW_VIRT_2.forEach(function (element, index) {
					gsap.timeline()
						.set(element, paramStart[index])
						.to (element, {duration: DURA_BEFORE, ease: ANI_BOUNCE_OUT, x: "0px"})
						.to (element, paramEnd[index], SW_GAP)
						.set(element, paramDef(0.0));
				});
				break;

			case STINGER_TYPE_CLOSE_02:
				paramStart	= [	{ y: "-540px", opacity: 1.0 }, { y: "540px", opacity: 1.0 }];
				paramEnd	= [
								{ duration: DURA_AFTER, ease: ANI_EASE_IN, y: "-540px" }
							,	{ duration: DURA_AFTER, ease: ANI_EASE_IN, y: "540px" }
							];
				SW_HORI_2.forEach(function (element, index) {
					gsap.timeline()
						.set(element, paramStart[index])
						.to (element, {duration: DURA_BEFORE, ease: ANI_BOUNCE_OUT, y: "0px"})
						.to (element, paramEnd[index], SW_GAP)
						.set(element, paramDef(0.0));
				});
				break;

			case STINGER_TYPE_CLOSE_03:
				const paramStartY	= ["-1080px", "1080px"];
				const paramEndY		= ["1080px",  "-1080px"];
				SW_VIRT_8.forEach(function (element, index) {
					gsap.timeline()
						.set(element,  { scaleX:0.1, y:paramStartY[index%2] })
						.to (element,  { duration: 0.3, ease: ANI_EASE_IN,  opacity: 1.0, scaleX:1.0, y:"0px", delay:index * 0.05 })
						.to (ELEM_ROOT, pColorMid[index])
						.to (element,  { duration: 0.4, ease: ANI_EASE_OUT, opacity: 0.0, scaleX:0.1, y:paramEndY[index%2] }, "+=0.5")
						.set(ELEM_ROOT, pColorEnd[index])
						.set(element, paramDef(0.0));
				});
				break;

			case STINGER_TYPE_CLOSE_04:
				const paramStartX	= ["-1920px", "1920px"];
				const paramEndX		= ["1920px",  "-1920px"];
				SW_HORI_8.forEach(function (element, index) {
					gsap.timeline()
						.set(element,  { x:paramStartX[index%2], opacity: 1.0 })
						.set(ELEM_ROOT, pColorMid[index])
						.to (element,  { duration: 0.3, ease: ANI_EASE_IN, x:"0px", delay:index * 0.05 })
						.to (element,  { duration: 0.4, ease: ANI_EASE_IN, x:paramEndX[index%2] }, "+=1.0")
						.set(ELEM_ROOT, pColorEnd[index])
						.set(element, paramDef(0.0));
				});
				break;
		}
	}

	// スティンガー実行（テキスト）
	exStingerText(newStingerState) {
		let stingerText		= Number(jsonData[SbJSON.STINGER_TEXT]);
		let stingerTextType = Number(jsonData[SbJSON.STINGER_TEXT_TYPE]);
		let arrNewText = ["", ""];
		let paramStart;
		let paramEnd;
		let paramDef = function (op) {
			return {scale: 1.0, opacity: op, x: "0px", y: "0px", textShadow: "none", letterSpacing: "normal",
					transformPerspective: 1080, transformOrigin: "50% 50%", justifyContent: "center", alignItems: "center",
					rotationY: 0, rotationX: 0, rotationZ: 0, skewX: 0, webkitFilter: "blur(0px)"}};
		const SW_GAP_TXT	= "+=0.3";
		const SW_GAP_VS		= "+=0.4";
		const popMoveY		= ["-900px", "900px"];


		if (STINGER_TEXT_NONE != stingerText) {

			if (STINGER_TEXT_TYPE_RANDOM == stingerTextType) {
				stingerTextType = Math.floor(Math.random() * (STINGER_TEXT_TYPE_RANDOM_END - STINGER_TEXT_TYPE_RANDOM_START)) + STINGER_TEXT_TYPE_RANDOM_START;
			}

			if (STINGER_TEXT_EVENT == stingerText) {
				const cssEvent = SbCSS.TXT_STINGER_EVENT;

				// イベント名を取得し１文字ずつ分割
				jQuery(cssEvent).css({ opacity: 0.0 });
				jQuery(cssEvent).text(YmsbAnime.fitTextWidth(jsonData[SbJSON.EVENT_NAME], cssEvent));
				let eventStinger = jQuery(cssEvent)[0];
				let eventArr = eventStinger.innerText.split("");
				eventStinger.innerHTML = "";
				for (let i = 0; i < eventArr.length; i++) {
					if (" " == eventArr[i]) {
						eventArr[i] = "&nbsp;";
					}
					eventStinger.innerHTML += "<span>" + eventArr[i] + "</span>";
				}
				/*
								// この処理でも分割可能だが、半角空白が認識し辛いため上記の処理とした。
								eventStinger.innerHTML = eventStinger.innerText
															.split("")
															.map(element => "<span>" + element + "</span>")
															.join("");
				*/

				/// イベント名のアニメーション
				switch (stingerTextType) {

					case STINGER_TEXT_TYPE_ZOOM_OUT:
						gsap.timeline()
							.set(cssEvent, { scale: 20.0, webkitFilter: "blur(3px)" })
							.to (cssEvent, { duration: 0.3, scale: 1.2,  ease: ANI_EASE_IN,   opacity: 1.0, webkitFilter: "blur(0px)" }, SW_GAP_TXT)
							.to (cssEvent, { duration: 0.9, scale: 1.25, ease: ANI_EASE_NONE })
							.to (cssEvent, { duration: 0.2, scale: 20.0,  ease: ANI_EASE_IN,   opacity: 0.0, webkitFilter: "blur(5px)" })
							.set(cssEvent, paramDef(0.0));
						break;

					case STINGER_TEXT_TYPE_POP:
						gsap.timeline()
							.set([cssEvent + " span", cssEvent], paramDef(0.0))
							.set(cssEvent + " span", { opacity: 0.0, scaleX: 0.1, scaleY: 10.0, scale: 10.0 })
							.set(cssEvent, { opacity: 1.0 })
							.to (cssEvent + " span", { opacity: 1.0, duration: 0.2, scaleX: 1.0, scaleY: 1.0, scale: 1.1, ease: ANI_EASE_IN
								, stagger: { amount: 0.3, from: "start" } }, SW_GAP_TXT)
							.to (cssEvent + " span", { opacity: 0.0, duration: 0.2, scaleX: 0.1, scaleY: 10.0, scale: 10.0, ease: ANI_EASE_IN
								, stagger: { amount: 0.3, from: "start" } }, SW_GAP_TXT)
							.set(cssEvent, paramDef(0.0));
						break;

					case STINGER_TEXT_TYPE_DROP:
						gsap.timeline()
							.set([cssEvent + " span", cssEvent], paramDef(0.0))
							.set(cssEvent + " span", { opacity: 0.0, scale: 12.0 })
							.set(cssEvent, { opacity: 1.0 })
							.to (cssEvent + " span", { opacity: 1.0, duration: 0.2, scale: 1.1, ease: ANI_BOUNCE_OUT
								, stagger: { amount: 0.3, from: "random" } }, SW_GAP_TXT)
							.to (cssEvent + " span", { opacity: 0.0, duration: 0.2, scale:20.0, ease: ANI_EASE_IN
								, stagger: { amount: 0.3, from: "random" } }, SW_GAP_TXT)
							.set(cssEvent, paramDef(0.0));
						break;
				}
			}
			else { // (STINGER_TEXT_NAME == stingerText)

				const arrCSSTxtStinger = [SbCSS.TXT_STINGER_1P, SbCSS.TXT_STINGER_2P];
				// 文字設定
				arrNewText.forEach(function (element, index) {
					if (STINGER_BG_NEXT_BATTLE == newStingerState) {
						element = YMSB_TXT_STINGER_NEXT_PLAYER[index];
					}
					else {
						element = jsonData[JSON_PLAYER_NAME[index]];
					}
					jQuery(arrCSSTxtStinger[index]).text(YmsbAnime.fitTextWidth(element, arrCSSTxtStinger[index]));

					// １文字ずつ分割
					let eventStinger = jQuery(arrCSSTxtStinger[index])[0];
					let eventArr = eventStinger.innerText.split("");
					eventStinger.innerHTML = "";
					for (let i = 0; i < eventArr.length; i++) {
						if (" " == eventArr[i]) {
							eventArr[i] = "&nbsp;";
						}
						eventStinger.innerHTML += "<span>" + eventArr[i] + "</span>";
					}
				});

				// 中央の文字（デフォルトはVS）のアニメーション
				if (STINGER_BG_NEXT_BATTLE != newStingerState) {
					gsap.timeline()
						.set(SbCSS.TXT_STINGER_VS, paramDef(0.0))
						.set(SbCSS.TXT_STINGER_VS, { scale: 20.0, rotationZ: 360 })
						.to (SbCSS.TXT_STINGER_VS, { duration: 0.5, ease: ANI_EASE_IN, scale: 1.5, rotationZ: 0, opacity: 1.0, webkitFilter: "blur(0px)" }, SW_GAP_VS)
						.to (SbCSS.TXT_STINGER_VS, { duration: 0.4, ease: ANI_EASE_OUT, textShadow: "0px 0px 100px #FFF", yoyo: true, repeat: 1 })
						.to (SbCSS.TXT_STINGER_VS, { duration: 0.3, ease: ANI_EASE_IN, scale: 20.0, webkitFilter: "blur(3px)" })
						.set(SbCSS.TXT_STINGER_VS, paramDef(0.0));
				}

				// チーム名・NEXT BATTLEのアニメーション
				switch (stingerTextType) {
/*
case STINGER_TEXT_TYPE_ZOOM_IN:
case STINGER_TEXT_TYPE_SLIDE_01:
case STINGER_TEXT_TYPE_SLIDE_02:
case STINGER_TEXT_TYPE_SLIDE_03:
case STINGER_TEXT_TYPE_SLIDE_04:
*/
					case STINGER_TEXT_TYPE_ZOOM_OUT:
						arrCSSTxtStinger.forEach(function (element, index) {
							const position = ["-480px", "480px"];
							paramStart = { scale: 6.0, x: "0px", y: position[index], opacity: 0.0, webkitFilter: "blur(3px)" };
							paramEnd = { duration: 0.2, scale: 6.0, y: position[index], ease: ANI_EASE_IN, opacity: 0.0, webkitFilter: "blur(5px)" }
							gsap.timeline()
								.set(element, paramDef(0.0))
								.set(element, paramStart)
								.to (element, { duration: 0.5, scale: 1.2,  y: "0px", ease: ANI_EASE_IN,   opacity: 1.0, webkitFilter: "blur(0px)" }, SW_GAP_TXT)
								.to (element, { duration: 0.7, scale: 1.25, y: "0px", ease: ANI_EASE_NONE, opacity: 1.0 })
								.to (element, paramEnd)
								.set(element, paramDef(0.0));
						});
						break;

					case STINGER_TEXT_TYPE_POP:
						arrCSSTxtStinger.forEach(function (element, index) {
							gsap.timeline()
								.set([element + " span", element], paramDef(0.0))
								.set(element + " span", { opacity: 0.0, scaleX: 0.1, scaleY: 10.0, scale: 10.0, y:popMoveY[index] })
								.set(element, { opacity: 1.0 })
								.to (element + " span", { opacity: 1.0, duration: 0.2, scaleX: 1.0, scaleY: 1.0, scale: 1.1, ease: ANI_EASE_IN
														, y:"0px", stagger: { amount: 0.3, from: "start" } }, SW_GAP_TXT)
								.to (element + " span", { opacity: 0.0, duration: 0.3, scaleX: 0.1, scaleY: 10.0, ease: ANI_EASE_IN 
														, y:"0px", stagger: { amount: 0.3, from: "start" } }, SW_GAP_TXT)
								.set(element, paramDef(0.0));
						});
						break;

					case STINGER_TEXT_TYPE_DROP:
						arrCSSTxtStinger.forEach(function (element) {
							gsap.timeline()
								.set([element + " span", element], paramDef(0.0))
								.set(element + " span", { opacity: 0.0, scale: 12.0 })
								.set(element, { opacity: 1.0 })
								.to (element + " span", {
									opacity: 1.0, duration: 0.3, scale: 1.1, ease: ANI_BOUNCE_OUT,
									stagger: { amount: 0.3, from: "random" }
								}, SW_GAP_TXT)
								.to (element + " span", {
									opacity: 0.0, duration: 0.5, scale:1.2, ease: ANI_EASE_IN,
									stagger: { amount: 0.3, from: "random" }
								}, SW_GAP_TXT)
								.set(element, paramDef(0.0));
						});
						break;
				}
			}
		}
	}

	// ■■ スティンガー背景の切り替え
	setStingerBack(newStingerState) {

		let stingerOptBackDef	= 1.0; // 背景画像。スティンガー時は常にON。
		let stingerOptBackGry	= 1.0; // 次戦、コメント表示時の背景グレーの端を補強。
		let stingerOptNextTxt	= 0.0;
		let stingerOptComment	= 0.0;
		let stingerParamBlur	= STINGER_BACK_BLUR_OFF;
		let stingerParamBack	= function(op, blur) {
			return {duration: ANI_COMP_BOX_BACK_CENTER, ease: ANI_EASE_IN,
				delay: ANI_DELY_BOX_BACK_CENTER, webkitFilter: blur, opacity: op}};
		let stingerParamComment	= function(op, css, txt) {
			return {duration: ANI_COMP_BOX_BACK_CENTER, opacity: op,
				ease: ANI_EASE_IN, delay: ANI_DELY_BOX_BACK_CENTER,
				onComplete: YmsbAnime.callBackTextUpdate(css, txt, "")}};

		// 次に表示する文字は毎回設定しておき、透過度で表示内容を制御する
		// 背景については設定画像かデフォルト画像かを状況によって切り分ける

		// 背景表示
		if		(STINGER_BG_IMAGE == newStingerState) {
			stingerOptBackGry	= 0.0;
		}
		// 次戦カード
		else if (STINGER_BG_NEXT_BATTLE == newStingerState) {
			stingerOptNextTxt	= 1.0;
			stingerParamBlur	= STINGER_BACK_BLUR_ON;
		}
		// コメント
		else if((STINGER_BG_COMMENT_TEAM == newStingerState)
			||	(STINGER_BG_COMMENT_PLAYER == newStingerState)) {
			stingerOptComment	= 1.0;
			stingerParamBlur	= STINGER_BACK_BLUR_ON;
		}
		else { // (STINGER_BG_GAME == newStingerState)
			stingerOptBackDef	= 0.0; // 標準背景画像はゲーム画面時のみOffにする。
			stingerOptBackGry	= 0.0;
		}

		// 【注】以下の「次戦表示」および「コメント表示」はON/OFFを兼ねているので
		// 　　　newStingerStateの値に関わらず実行している

		// 次戦表示
		const arrCSSTxtStingerNext = [SbCSS.TXT_STINGER_NEXT_1P, SbCSS.TXT_STINGER_NEXT_2P];
		gsap.to(SbCSS.TXT_STINGER_NEXT_CENTER, {
			duration: ANI_COMP_BOX_BACK_CENTER, opacity: stingerOptNextTxt,
			ease: ANI_EASE_IN, delay: ANI_DELY_BOX_BACK_CENTER
		});
		for (let i = 0; i < 2; i++) {
			let nextText = jsonData[JSON_NEXT_NAME[i]];
			let nextCSS  = arrCSSTxtStingerNext[i];
			gsap.to(nextCSS, {
				duration: ANI_COMP_BOX_BACK_CENTER, opacity: stingerOptNextTxt,
				ease: ANI_EASE_IN, delay: ANI_DELY_BOX_BACK_CENTER,
				onComplete: YmsbAnime.callBackTextUpdate(nextCSS, nextText, "")
			});
		}

		// コメント表示
		const arrCSSBoxComment		= [SbCSS.BOX_COMMENT_1P,		SbCSS.BOX_COMMENT_2P];
		const arrCSSTxtCommentName	= [SbCSS.TXT_COMMENT_NAME_1P,	SbCSS.TXT_COMMENT_NAME_2P];
		const arrCSSTxtCommentNote	= [SbCSS.TXT_COMMENT_NOTE_1P,	SbCSS.TXT_COMMENT_NOTE_2P];
		for (let i = 0; i < 2; i++) {
			let commentName;
			let commentOrder = parseInt(jsonData[JSON_MEMBER_ORDER[i]]);
			let commentNote;
			const arrJsonMemberName	= jsonData[JSON_MEMBER_NAME[i]];
			const arrJsonMemberComm	= jsonData[JSON_MEMBER_COMM[i]];
			if ((STINGER_BG_COMMENT_TEAM == newStingerState) || (0 == commentOrder)) {
				commentName = jsonData[JSON_PLAYER_NAME[i]];
				commentNote = jsonData[JSON_PLAYER_COMM[i]];
			}
			else {
				commentName = arrJsonMemberName[commentOrder];
				commentNote = arrJsonMemberComm[commentOrder];
			}

			gsap.to(arrCSSBoxComment[i], {
				duration: ANI_COMP_BOX_BACK_CENTER, opacity: stingerOptComment,
				ease: ANI_EASE_IN, delay: ANI_DELY_BOX_BACK_CENTER
			});
			gsap.to(arrCSSTxtCommentName[i], stingerParamComment(stingerOptComment, arrCSSTxtCommentName[i], commentName));
			gsap.to(arrCSSTxtCommentNote[i], stingerParamComment(stingerOptComment, arrCSSTxtCommentNote[i], commentNote));
		}

		// 画像設定
		gsap.to(SbCSS.BOX_BACK_STINGER_DEF,		stingerParamBack(stingerOptBackDef, stingerParamBlur));
		gsap.to(SbCSS.BOX_BACK_STINGER_GRAY,	stingerParamBack(stingerOptBackGry, STINGER_BACK_BLUR_OFF));
	}
}
