// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	勝利アニメーション表示
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

let currWinAnime	= YMSB_OFF;
let tlBack			= null;
let tlName			= null;
let scTicker		= "";

// ■■ 勝利アニメーションのパーティクル（キラキラ）のパラメータ ■■
const SC_WIN_ANIME_PARTICLE			= 
		{
			"bgColor": "#00000",
			"width": 1920,
			"height":1080,
			"emitFrequency": "60",
			"startX": 960,
			"startXVariance":1920,
			"startY": 540,
			"startYVariance":1080,
			"initialDirection": "90",
			"initialDirectionVariance": "0",
			"initialSpeed": 1.0,
			"initialSpeedVariance": 1.1,
			"friction": "0.030",
			"accelerationSpeed": 0.004,
			"accelerationDirection": 90,
			"startScale": 0.1,
			"startScaleVariance": 0.3,
			"finishScale": 1.4,
			"finishScaleVariance": "0.17",
			"lifeSpan": 120,
			"lifeSpanVariance": "188",
			"startAlpha": 0.8,
			"startAlphaVariance": "0.58",
			"finishAlpha": "0",
			"finishAlphaVariance": 0.5,
			"shapeIdList": [
				"blur_circle"
			],
			"startColor": {
				"hue": 39,
				"hueVariance": "41",
				"saturation": "59",
				"saturationVariance": "0",
				"luminance": "85",
				"luminanceVariance": "18"
			},
			"blendMode": true,
			"alphaCurveType": "1",
			"VERSION": "1.0.0"
		};

const SC_WIN_ANIME_PARTICLE_START	= 
		{
			"bgColor": "#00000",
			"width": 1920,
			"height":1080,
			"emitFrequency": "120",
			"startX": 960,
			"startXVariance":0,
			"startY": 540,
			"startYVariance":0,
			"initialDirection": "0",
			"initialDirectionVariance": "360",
			"initialSpeed": 30.0,
			"initialSpeedVariance": 1.1,
			"friction": "0.010",
			"accelerationSpeed": 0.05,
			"accelerationDirection": 90,
			"startScale": 5.0,
			"startScaleVariance": 0.3,
			"finishScale": 1.4,
			"finishScaleVariance": "0.17",
			"lifeSpan": 100,
			"lifeSpanVariance": "188",
			"startAlpha": 0.8,
			"startAlphaVariance": "0.58",
			"finishAlpha": "0",
			"finishAlphaVariance": 0.0,
			"shapeIdList": [
				"blur_circle"
			],
			"startColor": {
				"hue": 39,
				"hueVariance": "41",
				"saturation": "59",
				"saturationVariance": "0",
				"luminance": "85",
				"luminanceVariance": "18"
			},
			"blendMode": true,
			"alphaCurveType": "1",
			"VERSION": "1.0.0"
		};

// ■■ 初期化処理 ■■
function winAnimeInit() {
	winnerStage = new createjs.Stage(SbCSS.BOX_SPLASH_NH);
	winnerParticle = new particlejs.ParticleSystem();
	winnerStage.addChild(winnerParticle.container);
	createjs.Ticker.framerate = 30;
}

// ■■ アニメーション処理 ■■
function winAnime(){

	let newWinAnime = jsonData[SbJSON.WIN_ANIME];
	const WIN_WHITE_OUT		= "+=1.6";
	const cssWo = SbCSS.BOX_WHITE_OUT;
	const cssBw = SbCSS.BOX_WINNER;
	const cssTw = SbCSS.TXT_WINNER;

	// 勝利画像表示アニメーション
	if (YMSB_OFF == currWinAnime && YMSB_OFF != newWinAnime) {

		// スプラッシュ
		// 参考：https://ics.media/entry/11172/
		gsap.to(SbCSS.BOX_SPLASH, {delay:0.0, opacity:1.0, overwrite:"auto", onStart:function(){winnerParticle.importFromJson(SC_WIN_ANIME_PARTICLE_START);}});
		scTicker = createjs.Ticker.on("tick", scWinAnimeHandleTick);

		// ホワイトアウト
		gsap.timeline()
			.to(cssWo, {duration:1.5, opacity:1.0, onComplete:function(){winnerParticle.importFromJson(SC_WIN_ANIME_PARTICLE);}})
			.to(cssWo, {duration:5.0, opacity:0.0, overwrite:"auto"});

		// 背景画像
//		const randomInRange = function(min, max) {return Math.random() * (max - min) + min;};
		const conf_pc		= 120;		// 紙吹雪の数
		const conf_ticks	= 300;		// 紙吹雪が消えるタイミング
		const conf_colors	= ["#FFC", "#BB8", "#884", "#660", "#FFE"];		// 紙吹雪の色
		const conf_spread	= 45;		// 紙吹雪の広がり方
		const conf_velo		= 110;		// 紙吹雪が上に飛ぶ速度
		const conf_scalar	= 2.5;		// 紙吹雪の大きさ
		const conf_gravity	= 0.4;		// 重力 （0にすると紙吹雪が落ちない）
		const conf_emission	= 10;		// １F内での発射頻度
		const conf_param	= function(ag, moveX, moveY) {
			return {
				particleCount		: conf_pc,
				ticks				: conf_ticks,
				colors				: conf_colors,
				spread				: conf_spread,
				startVelocity		: conf_velo,
				scalar				: conf_scalar,
				gravity				: conf_gravity,
				emissionFrequency	: conf_emission,
				angle: ag,							// 紙吹雪が飛ぶ方向（指定しないと90=上向き）
				origin: { x: moveX, y: moveY }		// 紙吹雪の発生場所（両方とも0.5にすると中央）
			}};
		tlBack = gsap.timeline()
			.set(cssBw, {scale:0.0})
			.to (cssBw, {duration:0.3, opacity:1.0, scale:0.98, ease:ANI_EASE_OUT,
				onStart:function(){
					confetti(conf_param( 40, -0.15, 1.0));
					confetti(conf_param(140,  1.15, 1.0));
					confetti(conf_param( 90,  0.5,  1.35));
				}}, WIN_WHITE_OUT)
			.to (cssBw, {duration:2.0, scale:1.0, ease:ANI_EASE_OUT})
			.to (cssBw, {duration:2.0, repeat:-1, yoyo:true, overwrite:"auto", ease:ANI_EASE_IN,
				webkitFilter:"drop-shadow(0px 0px 20px rgba(255, 255, 200, 1.0)"});
		gsap.to(SbCSS.BOX_WINNER_SHADE, {duration:0.5, delay:1.5, opacity:0.7, overwrite:"auto"});

		// 勝利者名
		const txtPlayer = jsonData[JSON_PLAYER_NAME[newWinAnime - 1]];
		jQuery(SbCSS.TXT_WINNER).text(YmsbAnime.fitTextWidth(txtPlayer, SbCSS.TXT_WINNER));
		tlName = gsap.timeline()
			.set(cssTw, {scale:1.5, textShadow:"0px 0px 3px #FFF", transformPerspective: 1080, transformOrigin: "50% 50%", rotationX: 25})
			.to (cssTw, {duration:0.5, opacity:1.0, scale:0.98, ease:ANI_EASE_OUT}, WIN_WHITE_OUT)
			.to (cssTw, {duration:2.0, scale:1.0, ease:ANI_EASE_OUT})
			.to (cssTw, {duration:2.0, repeat:-1, yoyo:true, overwrite:"auto", ease:ANI_EASE_IN, color:"#FFF", textShadow:"0px 0px 40px #FFB"});
	}
	else if (YMSB_OFF != currWinAnime && YMSB_OFF == newWinAnime) {

		gsap.to (SbCSS.BOX_WINNER_SHADE, {duration:ANI_DUR_BASE, opacity:0.0});
		gsap.timeline()
			.set(cssBw, {repeat:0, yoyo:false, webkitFilter:"drop-shadow(0px 0px 5px rgba(255, 255, 255, 0.7)"})
			.to (cssBw, {duration:ANI_DUR_BASE, ease:ANI_EASE_IN, scale:1.5, opacity:0.0, onComplete:function(){tlBack.kill(); tlBack = null;}});
		gsap.timeline()
			.set(cssTw, {repeat:0, yoyo:false, color:"#FFB", textShadow:"0px 0px 0px #FFF"})
			.to (cssTw, {duration:ANI_DUR_BASE, ease:ANI_EASE_IN, scale:1.2, opacity:0.0, onComplete:function(){tlName.kill(); tlName = null;}});
		gsap.to(SbCSS.BOX_SPLASH,  {duration:ANI_DUR_BASE, opacity:0.0, onComplete:function(){createjs.Ticker.off("tick", scTicker);}});
	}
	else {
		// nop
	}
	currWinAnime = newWinAnime;
}

// ■■ イベントハンドラ（30fpsで稼働） ■■
function scWinAnimeHandleTick() {
	winnerParticle.update();
	winnerStage.update();
}
