/* ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

	YMSB
	Copyright YM 2022.

	Twitter @YmBlaze

■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■ */

// ■■ ファイル格納場所
const YMSB_TEMP						= "01_SF6/";

// ■■ 長期戦背景画像の透明度（不透明→1.0～0.0←透明）
const ANIME_LB_OPACITY				= 0.8;

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	各テキストサイズの設定
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
const YMSB_TXT_WIDTH_TEAM			= 360;				// チーム名
const YMSB_TXT_WIDTH_TEAM_CLAMP		= 2;
const YMSB_FONT_SIZE_TEAM			= 28;
const YMSB_FONT_SIZE_TEAM_MIN 		= 16;

const YMSB_TXT_WIDTH_STAGE			= 240;				// ステージ名
const YMSB_TXT_WIDTH_STAGE_CLAMP	= 1;
const YMSB_FONT_SIZE_STAGE			= 22;
const YMSB_FONT_SIZE_STAGE_MIN		= 18;

const YMSB_TXT_WIDTH_EVENT			= 440;				// イベント名
const YMSB_TXT_WIDTH_EVENT_CLAMP	= 1;
const YMSB_FONT_SIZE_EVENT			= 22;
const YMSB_FONT_SIZE_EVENT_MIN		= 18;

const YMSB_TXT_WIDTH_NOW			= 300;				// 対戦中プレイヤー名
const YMSB_TXT_WIDTH_NOW_CLAMP		= 1;
const YMSB_FONT_SIZE_NOW			= 22;
const YMSB_FONT_SIZE_NOW_MIN		= 18;

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	フォント・スキンの設定
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
arrFonts = [
	[YMSB_FONT_01	, YMSB_FONT_02	, YMSB_FONT_03	, YMSB_FONT_04	, YMSB_FONT_05	, YMSB_FONT_06	, YMSB_FONT_07	, YMSB_FONT_08	] // FONT_NAME
,	[0				, 2				, 0				, 0				, 0				, 0				, 0				, -1			] // FONT_TOP_STAGE
,	[0				, 0				, 0				, 0				, 0				, 0				, -1			, -2			] // FONT_TOP_TEAM
,	[0				, 0				, 0				, 0				, 0				, 0				, -2			, -3			] // FONT_TOP_SCORE
,	[0				, 2				, 0				, 0				, 0				, 0				, -1			, -1			] // FONT_TOP_NOW
,	[0				, 2				, 0				, 0				, 0				, 0				, -2			, -2			] // FONT_TOP_STAR
,	[0				, 1				, 0				, 0				, 0				, 0				, -2			, -2			] // FONT_TOP_EVENT
,	[0				, 2				, 0				, 2				, 0				, 1				, 0				, 1				] // FONT_TOP_LB
];
arrSkins = [
	["01/", 	"02/",		"03/",		"04/",		"05/",		"06/",		"07/",		"08/",		"09/",		]	// SKIN_NUMBER
,	["#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#800000"	]	// COLOR_BODY_TXT
,	["#000000",	"#000000",	"#333333",	"#333333",	"#333333",	"#000000",	"#333333",	"#000000",	"#800000"	]	// COLOR_BODY_SHADE
,	["#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#800000"	]	// COLOR_STAGE_TXT
,	["#000000",	"#000000",	"#333333",	"#333333",	"#333333",	"#000000",	"#333333",	"#000000",	"#800000"	]	// COLOR_STAGE_SHADE
,	["#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#000080"	]	// COLOR_TEAM_TXT_1P
,	["#000000",	"#000000",	"#333333",	"#000000",	"#333333",	"#000000",	"#000000",	"#000000",	"#000080"	]	// COLOR_TEAM_SHADE_1P
,	["#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#000080"	]	// COLOR_TEAM_TXT_2P
,	["#000000",	"#000000",	"#333333",	"#000000",	"#333333",	"#000000",	"#000000",	"#000000",	"#000080"	]	// COLOR_TEAM_SHADE_2P
,	["#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#000080"	]	// COLOR_SCORE_TXT_1P
,	["#000000",	"#000000",	"#333333",	"#000000",	"#333333",	"#000000",	"#000000",	"#000000",	"#000080"	]	// COLOR_SCORE_SHADE_1P
,	["#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#FFFFFF",	"#000080"	]	// COLOR_SCORE_TXT_2P
,	["#000000",	"#000000",	"#333333",	"#000000",	"#333333",	"#000000",	"#000000",	"#000000",	"#000080"	]	// COLOR_SCORE_SHADE_2P
,	["#AA000D",	"#AA000D",	"#AAAAAA",	"#7ecef4",	"#79001a",	"#770b01",	"#f61b77",	"#cf1700",	"#800000"	]	// COLOR_MEMBER_BOX_1P
,	["#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#800000"	]	// COLOR_MEMBER_NOW_1P
,	["#ec6941",	"#ec6941",	"#000000",	"#06b0e3",	"#79001a",	"#aa3333",	"#204a5a",	"#ec6941",	"#800000"	]	// COLOR_MEMBER_BORDER_1P
,	["#00479D",	"#00479D",	"#AAAAAA",	"#7ecef4",	"#0e3671",	"#770b01",	"#f61b77",	"#0733bf",	"#800000"	]	// COLOR_MEMBER_BOX_2P
,	["#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#FFFF33",	"#800000"	]	// COLOR_MEMBER_NOW_2P
,	["#06b0e3",	"#06b0e3",	"#000000",	"#06b0e3",	"#0e3671",	"#aa3333",	"#204a5a",	"#06b0e3",	"#800000"	]	// COLOR_MEMBER_BORDER_2P
];

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	共通定数/変数
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ 団体戦メンバー表示関連
const YMSB_MEMBER_POSITION_TOP		= 325;

const arrBottomSize = [
// 下段サイズ	下段画像Left値	メンバー表示領域	
 ["1100px",		"410px",		635		] // BOTTOM_SIZE_SHORT
,["1100px",		"410px",		635		] // BOTTOM_SIZE_WIDE
];
const BOTTOM_SIZE_SHORT				= 0;
const BOTTOM_SIZE_WIDE				= 1;
const BOTTOM_SIZE_WIDTH				= 0;
const BOTTOM_SIZE_LEFT				= 1;
const BOTTOM_SIZE_MAX_HEIGHT		= 2;

const YMSB_OFF						= 0;
const YMSB_ON						= 1;

// ■■ アニメーション用パラメータ
const YMSB_UP						= "+";
const YMSB_DOWN						= "-";
const YMSB_LEFT						= "+";
const YMSB_RIGHT					= "-";
const YMSB_VIRT						= 0;
const YMSB_HORI						= 1;

const ANI_MOVE_DEFAULT				= "0px";
const ANI_MOVE_Y_BLOCK_01			= "45px";
const ANI_MOVE_Y_BLOCK_02			= "90px";
const ANI_MOVE_Y_BLOCK_03			= "135px";
const ANI_MOVE_X_MEMBER				= "240px";
const ANI_MOVE_BOX_SIDE				= 400;		// 勝ち星・スコア・ロゴ・メンバー背景

// ■■ 各アニメーション設定
const ANIME_STAGE_BOX				= YMSB_DOWN + ANI_MOVE_Y_BLOCK_01;
const ANIME_STAGE_TXT				= YMSB_DOWN + ANI_MOVE_Y_BLOCK_01;
const ANIME_EVENT_BOX_TOP			= YMSB_DOWN + ANI_MOVE_Y_BLOCK_01;
const ANIME_EVENT_TXT_TOP			= YMSB_DOWN + ANI_MOVE_Y_BLOCK_01;
const ANIME_EVENT_BOX_BOTTOM		= YMSB_UP   + ANI_MOVE_Y_BLOCK_01;
const ANIME_EVENT_TXT_BOTTOM		= YMSB_UP   + ANI_MOVE_Y_BLOCK_01;
const ANIME_TEAM_BOX_VH				= YMSB_VIRT;
const ANIME_TEAM_TXT_VH				= YMSB_HORI;
const ANIME_TEAM_BOX_01				= YMSB_UP + ANI_MOVE_Y_BLOCK_02;
const ANIME_TEAM_TXT_01				= YMSB_RIGHT + ANI_MOVE_BOX_SIDE + "px"
const ANIME_TEAM_BOX_02				= YMSB_UP + ANI_MOVE_Y_BLOCK_02;
const ANIME_TEAM_TXT_02				= YMSB_LEFT  + ANI_MOVE_BOX_SIDE + "px"
const ANIME_SCORE_BOX_VH			= YMSB_VIRT;
const ANIME_SCORE_BOX_01			= YMSB_UP + ANI_MOVE_Y_BLOCK_02;
const ANIME_SCORE_BOX_02			= YMSB_UP + ANI_MOVE_Y_BLOCK_02;
const ANIME_SCORE_TXT_VH			= YMSB_VIRT;
const ANIME_SCORE_TXT_01			= 0;
const ANIME_SCORE_TXT_02			= 0;
const ANIME_BOTTOM_BOX				= YMSB_UP + ANI_MOVE_Y_BLOCK_03;
const ANIME_BOTTOM_TXT				= YMSB_UP + ANI_MOVE_Y_BLOCK_03;
const ANIME_NOW_BOX_VH				= YMSB_VIRT;
const ANIME_NOW_BOX_01				= YMSB_DOWN  + ANI_MOVE_Y_BLOCK_03;
const ANIME_NOW_BOX_02				= YMSB_DOWN  + ANI_MOVE_Y_BLOCK_03;
const ANIME_NOW_TXT_VH				= YMSB_HORI;
const ANIME_NOW_TXT_01				= YMSB_RIGHT + ANI_MOVE_BOX_SIDE + "px";
const ANIME_NOW_TXT_02				= YMSB_LEFT  + ANI_MOVE_BOX_SIDE + "px";
const ANIME_STAR_BOX_VH				= YMSB_VIRT;
const ANIME_STAR_BOX_01				= YMSB_DOWN  + ANI_MOVE_Y_BLOCK_03;
const ANIME_STAR_BOX_02				= YMSB_DOWN  + ANI_MOVE_Y_BLOCK_03;
const ANIME_LOGO_BOX_VH				= YMSB_HORI;
const ANIME_LOGO_BOX_01				= YMSB_RIGHT + ANI_MOVE_BOX_SIDE + "px";
const ANIME_LOGO_BOX_02				= YMSB_LEFT  + ANI_MOVE_BOX_SIDE + "px";
const ANIME_LB_TXT_VH				= YMSB_HORI;
const ANIME_LB_TXT_01				= YMSB_RIGHT + ANI_MOVE_BOX_SIDE + "px";
const ANIME_LB_TXT_02				= YMSB_RIGHT + ANI_MOVE_BOX_SIDE + "px";
const ANIME_LB_BOX_01				= YMSB_UP + ANI_MOVE_Y_BLOCK_02;
const ANIME_SIDE					= YMSB_OFF;

document.write("<script src=\"js/main/_common.js\"></script> ");
