/* ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

	YMSB (common)
	Copyright YM 2022.

	Twitter @YmBlaze

■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■ */

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	表示設定
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

const YMSB_TXT_CHANGE_TIME			= "+=6.0";			// テキスト自動切換えの間隔
const YMSB_BOX_CHANGE_TIME			= "+=7.5";			// 画像自動切換えの間隔
const YMSB_MEMBER_BOX_OP			= 0.6;				// 団体戦メンバーの背景の透明度
const YMSB_MAX_MEMBER				= 18;				// 団体戦の最大人数
const YMSB_MAX_FIX_MEMBER			= 5;				// 団体戦枠の高さを固定にする人数
const YMSB_FIX_MEMBER_HEIGHT		= 100;				// ↑の場合の枠の高さ
const YMSB_MAX_SETS					= 19;				// 長期戦の最大セット数

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	各テキスト設定
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
 
const YMSB_TXT_LOSERS				= " -L-";				// ルーザーズ表記
const YMSB_TXT_NEXT					= "NEXT\nBATTLE";		// 画面下部の次戦カード
const YMSB_TXT_CLAMP				= "...";				// はみ出したテキストの省略文字

// ■■ 10先スコアの表記
const YMSB_TXT_LB_WIN				= "★";					// 勝ち
const YMSB_TXT_LB_LOSE				= "-";					// 負け
const YMSB_TXT_LB_DRAW				= "Ｄ";					// ドロー

// ■■ スティンガーの設定
const YMSB_TXT_VS					= "VS";					// スティンガー中央の文字
const YMSB_TXT_STINGER_NEXT_PLAYER	= ["NEXT", "BATTLE"];	// 次戦カードを表示する際の文字
const YMSB_TXT_STINGER_NEXT_CENTER	= "GET READY FOR THE NEXT BATTLE";
															// [Show Next Battle]の中央の文字

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	JSONファイル読み込み用パラメータ
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

let JSON_Remote						= YMSB_OFF;
let JSON_WebAPI						= "";
const JSON_FILE						= "streamcontrol/streamcontrol.json";
															// JSONファイルのファイルパス
const HANDLER_TIME					= 500;					// ハンドラのコールバック周期（ミリ秒）

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	アニメーション関連のパラメータ
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ アニメーション開始から完了までの時間（秒）
// 0.5以下だと不具合が発生する為、0.6以上で設定すること
const ANI_DUR_BASE					= 0.6;

// ■■ アニメーションディレイ（秒）
const ANI_DELY_INIT					= 0.5;		// 開始前に画像の読み込み時間を稼ぐ
const ANI_DELY_SECOND				= ANI_DELY_INIT * 2;
const ANI_DELY_THIRD				= ANI_DELY_INIT * 3;
const ANI_DELY_FOURTH				= ANI_DELY_INIT * 4;
const ANI_DELY_BOTTOM				= 1.0;

// 表示時のディレイ
// 表示時のディレイ
const ANI_DELY_ON_BOX_TEAM			= ANI_DELY_INIT;
const ANI_DELY_ON_BOX_NOW			= ANI_DELY_INIT;
const ANI_DELY_ON_BOX_STAGE			= ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_STAR			= ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_EVENT			= ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_SCORE			= ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_LB			= ANI_DELY_SECOND;
const ANI_DELY_ON_BOX_BOTTOM		= ANI_DELY_THIRD;
const ANI_DELY_ON_BOX_LOGO			= ANI_DELY_THIRD;
const ANI_DELY_ON_BOX_MEMBER		= ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_STAGE			= ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_TEAM			= ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_NOW			= ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_STAR			= ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_SCORE			= ANI_DELY_THIRD;
const ANI_DELY_ON_TXT_EVENT			= ANI_DELY_THIRD;
const ANI_DELY_ON_MEMBER 			= ANI_DELY_THIRD + 0.1;
const ANI_DELY_ON_TXT_BOTTOM		= ANI_DELY_THIRD;

const ANI_DELY_OFF_TXT				= ANI_DELY_SECOND;
const ANI_DELY_OFF_BOX				= ANI_DELY_SECOND;
const ANI_DELY_OFF_MEMBER			= ANI_DELY_SECOND;

const ANI_DELY_UPDATE				= ANI_DELY_SECOND;

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	各ファイル格納場所
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
const YMSB_COMM						= "common/"
const YMSB_URL_IMG					= "imgs/" + YMSB_TEMP;
const YMSB_URL_IMG_COMM				= "imgs/" + YMSB_COMM;
const YMSB_URL_MASK					= YMSB_URL_IMG + "mask/";
const YMSB_URL_USER					= YMSB_URL_IMG_COMM + "user/";
const YMSB_URL_LOGO					= YMSB_URL_IMG_COMM + "logo/";
const YMSB_IMAGE_EXT				= ".png";
const YMSB_COMMON_HTML				= "js/main/_common.txt";

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	各ファイル読み込み
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
// ■■ マスク画像設定
const setMask = () => {
	/*
	-webkit-mask-image: url("../imgs/09_SF6/mask/maskStar.png");
	mask-image: url("../imgs/09_SF6/mask/maskStar.png");
	*/
	const arrSkinMaskFile = [
			"maskStage"
		,	"maskTeam"
		,	"maskScore"
		,	"maskNow"
		,	"maskStar"
		,	"maskLogo"
		,	"maskLogoChara"
		,	"maskEvent"
		,	"maskBottom"
		,	"maskBottomTxtTop"
		,	"maskBottomTxtBottom"
	];
	for (const element of arrSkinMaskFile) {
		const cssId = "#" + element.charAt(0).toUpperCase() + element.slice(1);
		const maskURL = 'url("' + YMSB_URL_MASK + element + YMSB_IMAGE_EXT + '")';
		jQuery(cssId).css({
			"-webkit-mask-image"	: maskURL,
			"mask-image"			: maskURL});
	}
};
getHtml();
async function getHtml() {

	// 共通部描画
	const data = await fetch(YMSB_COMMON_HTML);
	const htmlData = await data.text();
	document.body.insertAdjacentHTML('beforeend', htmlData);

	// マスク画像設定
	setMask();

	// 団体戦メンバー描画
	const dataMembers = getHtmlMembers();
	const viewMembers = document.getElementById('viewMembers');
	viewMembers.insertAdjacentHTML('beforeend', dataMembers);

	// 長期戦スコア描画
	const dataScores = getHtmlScores();
	const viewScores = document.getElementById('viewScores');
	viewScores.insertAdjacentHTML('beforeend', dataScores);
}

// ■■ 共通部設定
const getHtmlMembers = () => {
	/*
	<div class="Box Member Name1p" id="BoxMemberName1p_01"></div>
	<div class="Box Member Name2p" id="BoxMemberName2p_01"></div>
	<div class="Txt Member Name1p" id="TxtMemberName1p_01"></div>
	<div class="Txt Member Name2p" id="TxtMemberName2p_01"></div>
	<div class="Box Member Life1p" id="BoxMemberLife1p_01"></div>
	<div class="Box Member Life2p" id="BoxMemberLife2p_01"></div>
	<div class="Txt Member Life1p" id="TxtMemberLife1p_01"></div>
	<div class="Txt Member Life2p" id="TxtMemberLife2p_01"></div>
	*/
	let tagMember = function(BoxOrTxt, NameOrLife, side, memberNum) {
		return '<div  class="' + BoxOrTxt + ' Member ' + NameOrLife + side + 'p" id="' + BoxOrTxt + 'Member' + NameOrLife + side + 'p_' + memberNum + '"></div>'};
	let data = "";

	for (let member = 1; member <= YMSB_MAX_MEMBER; member++) {
		let memberNum  = ('00' + member).slice(-2);
		for (let side = 1; side <= 2; side++) {
			data += tagMember("Box", "Name", side, memberNum);
			data += tagMember("Txt", "Name", side, memberNum);
			data += tagMember("Box", "Life", side, memberNum);
			data += tagMember("Txt", "Life", side, memberNum);
		}
	}
	return data;
};

// ■■ 長期戦スコア部設定
const getHtmlScores = () => {
	/*
	<div class="Txt LB Score Top    Set01" id="TxtLBScore1p_01"></div>
	<div class="Txt LB Score Bottom Set01" id="TxtLBScore2p_01"></div>
	*/
	let topOrBottom = function(side) {return side == "1" ? "Top" : "Bottom"};
	let tagLB = function(side, setNum) {
		return '<div  class="Txt LB Score ' + topOrBottom(side) + ' Set' + setNum +  '" id="TxtLBScore' + side + 'p_' + setNum + '"></div>'};
	let data = "";

	for (let set = 1; set <= YMSB_MAX_SETS; set++) {
		let setNum  = ('00' + set).slice(-2);
		data += tagLB("1", setNum);
		data += tagLB("2", setNum);
	}
	return data;
};

// ■■ スクリプトファイル読み込み ■■
const arrYMSBSource = [
	"cCSS.js"
,	"cJSON.js"
,	"cAnime.js"
,	"cCheck.js"
,	"cMain.js"
,	"cSkinFontCheck.js"
,	"cStageCheck.js"
,	"cEventCheck.js"
,	"cTeamNameCheck.js"
,	"cScoreCheck.js"
,	"cBottomCheck.js"
,	"cLB.js"
,	"cNowCheck.js"
,	"cLogoCheck.js"
,	"cMember.js"
,	"cMemberCheck.js"
,	"cSideCheck.js"
,	"cStingerCheck.js"
,	"cState.js"
,	"cWinAnime.js"
];
arrYMSBSource.forEach(function (element) {
	// Caution : document.write()は非推奨だが、他の手段が上手く動作しないのでこのまま。
	// 他の手段例：https://t-annex.com/donotusedocument-write/
	document.write("<script src=\"js/" + YMSB_COMM + element + "\"></script>");
});
/*
	const scriptMain = document.createElement('script');
	scriptMain.src ="js/" + YMSB_COMM + "sMain.min.js";
	scriptMain.type = "text/javascript";
	document.body.appendChild(scriptMain);
*/
