// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	イベントハンドラ
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ 初期設定 ■■
window.addEventListener("load", function() {
	setShortCut();
});

// ■■ 更新ボタン ■■
document.getElementById("upload").addEventListener("click", async (e) =>  {
	updateJSON();
});
async function updateJSON() {
	const jsonFromData = JSON.stringify(setJsonFromData(), null, " ");
	const writable = await fileHandle.createWritable();
	await writable.write(jsonFromData);
	await writable.close();

	// 内部データを更新
	dataFromJson = JSON.parse(jsonFromData);
}

// ■■ SWAPボタン（自動的に更新する） ■■
document.getElementById("swap").addEventListener("click", () =>  {
	swapData();
	updateJSON();
});

// ■■ ALLクリアボタン ■■
document.getElementById("clearAll").addEventListener("click", () =>  {
	clearData();
	if (YMSB_TYPE_EXPERT == YMSB_JSON_TYPE) {
		setLifeData(jQuery("#maxMemberLives").val());
	}
});

// ■■ CSVファイル読み込みボタン ■■
document.getElementById("loadCSV").addEventListener("click", async (e) =>  {
	copyToClipJsonFileName(YMSB_CSV_FILE_NAME);
	[CSVfileHandle] = await window.showOpenFilePicker();
	let csvData = await CSVfileHandle.getFile();
	csvData = await csvData.text();

	const CSV_DATA_LENGTH = 46;
	const data_string = csvData.split('\r\n');
	for (let i = 0; i < data_string.length; i++) {
		if (CSV_DATA_LENGTH < data_string[i].length) {
			csv_data_array[i] = data_string[i].split(',');
			csv_data_array[i].forEach(function(element, index){
				element = element.replace(/[\"]/g, "")
				element = element.replace(/[\n]/g, "\\n");
				csv_data_array[i][index] = element;
			});
		}
	}

	// オートコンプリートのデータ設定
	setAutoComplete();

	// エキスパートモードのみCSVタブ内のデータを書き込み
	// Load CSVをSave CSVに変更する
	if (YMSB_TYPE_EXPERT == YMSB_JSON_TYPE) {
		setCSVView();
		jQuery("#loadCSV").css("display", "none");
		jQuery("#saveCSV").css("display", "block");
	}
});

// ■■ JSONファイル指定とデータ展開 ■■
document.getElementById("init").addEventListener("click", async (e) => {
	copyToClipJsonFileName(YMSB_JSON_FILE_NAME);
	[fileHandle] = await window.showOpenFilePicker();
	const file = await fileHandle.getFile();
	dataFromJson = await file.text();
	dataFromJson = JSON.parse(dataFromJson);
	setDataFromJson();
});

// ■■ ヘルプページ（よくある質問集）に飛ぶ ■■
document.getElementById("help").addEventListener("click", () =>  {
	window.open(YMSB_HELP_URL, '_blank', 'noreferrer');
});

// ■■ 10先スコアが更新されていれば優先する ■■
document.getElementById("bottomView").addEventListener("change", () =>  {
	setScoreLB();
});

// ■■ メンバー、スコア遷移部の描画後に行う処理 ■■
window.onload = function() {

	// 言語設定（デフォルトは日本語）
	if (YMSB_TYPE_EXPERT == YMSB_JSON_TYPE) {
		setLanguage(YMSB_DEF_LANG, false);
	}

	// メンバー部の外部変数を設定
	if (YMSB_TYPE_EXPERT == YMSB_JSON_TYPE) {
		memberName_1	= document.querySelectorAll('input[name="mName1"]');
		memberName_2	= document.querySelectorAll('input[name="mName2"]');
		memberComm_1	= document.querySelectorAll('input[name="mComm1"]');
		memberComm_2	= document.querySelectorAll('input[name="mComm2"]');
		memberBack_1	= document.querySelectorAll('input[name="mBack1"]');
		memberBack_2	= document.querySelectorAll('input[name="mBack2"]');
		memberLoser_1	= document.querySelectorAll('input[name="mLoser1"]');
		memberLoser_2	= document.querySelectorAll('input[name="mLoser2"]');
		memberLife_1	= document.querySelectorAll('input[name="mLife1"]');
		memberLife_2	= document.querySelectorAll('input[name="mLife2"]');
	}

	// 長期戦スコアの外部変数を設定・イベントリスナー登録
	if (YMSB_TYPE_EXPERT == YMSB_JSON_TYPE) {
		scoreLB_1		= document.querySelectorAll('select[name="YMSB_LB_1"]');
		scoreLB_2		= document.querySelectorAll('select[name="YMSB_LB_2"]');
	}
	else {
		scoreLB_1		= document.querySelectorAll('input[name="YMSB_LB_1"]');
		scoreLB_2		= document.querySelectorAll('input[name="YMSB_LB_2"]');
	}
	const scoreLBCheck  = [scoreLB_1, scoreLB_2];
	for (let i = 0; i < 2; i++) {
		for (let score of scoreLBCheck[i]) {
			score.addEventListener("change", () => {
				setScoreLB();
			});
		}
	}
}

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	イベントハンドラで使う関数
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ JSONファイルのファイルパスをクリップボードにコピー ■■
const copyToClipJsonFileName = (fileName) => {
	let localPathName = decodeURI(location.pathname);
	localPathName = localPathName.slice(0, YMSB_FILEPATH_MATH);
	localPathName = localPathName.replace(/\//g, "\\");
	localPathName += fileName;

	// Windows以外（mac）の場合は[C:]を削除し[\]を[/]に置換
	let osCheck = window.navigator.userAgent.toLowerCase();
	if ( osCheck.indexOf("windows") == -1 ) {
		localPathName = localPathName.replace(/\\/g, "/");
	}
	else {
		localPathName = localPathName.slice(1);
	}

	navigator.clipboard.writeText(localPathName);
	return localPathName;
}

// ■■ スコア算出＆表示 ■■
const setScoreLB = () => {
	if ("1" == jQuery("#bottomView").val()) {
		let scores = [0, 0];
		let draw = false;
		if (YMSB_TYPE_EXPERT == YMSB_JSON_TYPE) {
			jQuery("#" + addDraw).prop("checked");
		}
		for (let i = 0; i < scoreLB_1.length; i++) {
	
			let newScore1p;
			let newScore2p;
			if (YMSB_TYPE_EXPERT == YMSB_JSON_TYPE) {
				newScore1p = scoreLB_1[i].value;
				newScore2p = scoreLB_2[i].value;
			}
			else {
				newScore1p = checkInput(scoreLB_1[i].checked);
				newScore2p = checkInput(scoreLB_2[i].checked);
			}

			// ドロー時を考慮してスコアを再計算
			if		(newScore1p > newScore2p) {
				scores[0] ++;
			}
			else if (newScore1p < newScore2p) {
				scores[1] ++;
			}
			else if (newScore1p == newScore2p) {
				if  ((0 != newScore1p) && (draw)) {
					scores[0] ++;
					scores[1] ++;
				}
			}
		}
		for (let i = 0; i < 2; i++) {
			jQuery(arrSingleScore[i]).val(scores[i]);
		}
	}
}

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	団体戦のライフ設定
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// 最大ライフ数を各メンバーに設定
const setLifeData = (value) => {
	if (0 == value) {value = "";}
	for (let i = 0; i < 2; i ++) {
		for (let member = 1; member <= YMSB_MAX_MEMBER; member++){
			let memberNum  = ('00' + member).slice(-2);
			jQuery(retID("#mLife1_", memberNum)).val(value);
			jQuery(retID("#mLife2_", memberNum)).val(value);
		}
	}
	setLifeScore();
};

// ライフ数変動でスコアを自動計算、ライフ最大数が……
// １の場合    ：自チームのスコア　＝　相手の敗者数
// ２以上の場合：自チームのスコア　＝　自チームの総ライフ数
const setLifeScore = () => {
	let life1p = 0;
	let life2p = 0;
	if("0" != jQuery("#maxMemberLives").val()) {
		if ("1" != jQuery("#maxMemberLives").val()) {
			for (let member = 1; member <= YMSB_MAX_MEMBER; member++){
				let memberNum  = ('00' + member).slice(-2);
				if (
					("" != jQuery(retID("#mName1_", memberNum)).val())
				&&	(false == jQuery(retID("#mLoser1_", memberNum)).prop("checked"))
				) {
					life1p += parseInt(jQuery(retID("#mLife1_", memberNum)).val());
				}
				if (
					("" != jQuery(retID("#mName2_", memberNum)).val())
				&&	(false == jQuery(retID("#mLoser2_", memberNum)).prop("checked"))
				) {
					life2p += parseInt(jQuery(retID("#mLife2_", memberNum)).val());
				}
			}
		}
		else {
			for (let member = 1; member <= YMSB_MAX_MEMBER; member++){
				let memberNum  = ('00' + member).slice(-2);
				if (("0" == jQuery(retID("#mLife1_", memberNum)).val())
				|| (true == jQuery(retID("#mLoser1_", memberNum)).prop("checked"))
				){life2p ++;}
				if (("0" == jQuery(retID("#mLife2_", memberNum)).val())
				|| (true == jQuery(retID("#mLoser2_", memberNum)).prop("checked"))
				){life1p ++;}
			}
		}
	}
	jQuery("#pScore1").val(life1p);
	jQuery("#pScore2").val(life2p);
};