/* ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

	YMSB(Control)

	Copyright YM 2022.

	Twitter @YmBlaze

■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■ */

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	外部変数
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

// ■■ JSONファイルの名前 ■■
const YMSB_JSON_FILE_NAME = "streamcontrol\\streamcontrol.json";

// ■■ CSVファイルの名前 ■■
const YMSB_CSV_FILE_NAME = "streamcontrol\\csv\\scData.csv";

// ■■ ヘルプページのURL ■■
const YMSB_HELP_URL		= "https://oreshufu.com/ymsb/qa";

// ■■ デフォルトで表示する言語（日本語） ■■
const YMSB_DEF_LANG		= 2;

// ■■ ツールチップ表示 ■■
const YMSB_TOOLTIP_ON	= false;

// ■■ 団体戦メンバー関係 ■■
const YMSB_MAX_MEMBER	= 18;
const YMSB_MAX_MEMBACK	= 5;
let retID = function(id, num) {return id + num};

// ■■ 長期戦最大セット数（１０先） ■■
const YMSB_MAX_SETS		= 19;

// ■■ ファイルハンドル（"open"で取得しておく） ■■
let fileHandle;
let CSVfileHandle;

// ■■ JSONファイルの初期データ（"open"で取得した実体） ■■
let dataFromJson;

// ■■ JSONファイル格納用配列など
let memberName_1;
let memberName_2;
let memberComm_1;
let memberComm_2;
let memberBack_1;
let memberBack_2;
let memberLoser_1;
let memberLoser_2;
let memberLife_1;
let memberLife_2;
let scoreLB_1;
let scoreLB_2;
const arrSingleScore	= ["#pScore1", "#pScore2"];
const addDraw			= "LB_Draw";
let checkInput = function(newScore) {return newScore ? 1 : 0};

// ■■ CSVファイルから読み込んだデータ ■■
let csv_data_array = [];

// ■■ オートコンプリート用データ
let csv_autoComplete = [];

// ■■ モード定数
const YMSB_TYPE_BASIC	= 0;
const YMSB_TYPE_EXPERT	= 1;
const YMSB_JSON_FILE_BASIC	= -29;
const YMSB_JSON_FILE_EXPERT	= -30;

// ■■ CSVデータ列挙体
const YMSB_CSV = {
	NO_INDEX			: 0,
	PLAYER_NAME			: 1,
	NOW_NAME			: 2,
	LOGO				: 3,
	PLAYER_COMMENT		: 4,
	PLAYER_IMAGE		: 5,
	MEMBER_NAME_01		: 6,
	MEMBER_BACK_01		: 7,
	MEMBER_NAME_02		: 8,
	MEMBER_BACK_02		: 9,
	MEMBER_NAME_03		: 10,
	MEMBER_BACK_03		: 11,
	MEMBER_NAME_04		: 12,
	MEMBER_BACK_04		: 13,
	MEMBER_NAME_05		: 14,
	MEMBER_BACK_05		: 15,
	MEMBER_NAME_06		: 16,
	MEMBER_NAME_07		: 17,
	MEMBER_NAME_08		: 18,
	MEMBER_NAME_09		: 19,
	MEMBER_NAME_10		: 20,
	MEMBER_NAME_11		: 21,
	MEMBER_NAME_12		: 22,
	MEMBER_NAME_13		: 23,
	MEMBER_NAME_14		: 24,
	MEMBER_NAME_15		: 25,
	MEMBER_NAME_16		: 26,
	MEMBER_NAME_17		: 27,
	MEMBER_NAME_18		: 28,
	MEMBER_COMMENT_01	: 29,
	MEMBER_COMMENT_02	: 30,
	MEMBER_COMMENT_03	: 31,
	MEMBER_COMMENT_04	: 32,
	MEMBER_COMMENT_05	: 33,
	MEMBER_COMMENT_06	: 34,
	MEMBER_COMMENT_07	: 35,
	MEMBER_COMMENT_08	: 36,
	MEMBER_COMMENT_09	: 37,
	MEMBER_COMMENT_10	: 38,
	MEMBER_COMMENT_11	: 39,
	MEMBER_COMMENT_12	: 40,
	MEMBER_COMMENT_13	: 41,
	MEMBER_COMMENT_14	: 42,
	MEMBER_COMMENT_15	: 43,
	MEMBER_COMMENT_16	: 44,
	MEMBER_COMMENT_17	: 45,
	MEMBER_COMMENT_18	: 46
};

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	団体戦メンバー部、10先スコア部のHTML
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
document.addEventListener("DOMContentLoaded", function() {
	let isExpert = true;

	// 団体戦メンバー描画
	const viewMembers = document.getElementById('viewMembers');
	if (null != viewMembers) {
		const dataMembers = setHtmlMember();
		viewMembers.insertAdjacentHTML('beforeend', dataMembers);
	}
	else {
		isExpert = false;
	}

	// 10先スコア描画
	const viewScores = document.getElementById('viewScores');
	if (null != viewScores) {
		const dataScores = setHtmlScore(isExpert);
		viewScores.insertAdjacentHTML('beforeend', dataScores);
	}
});

// ■■ 団体戦メンバーデータ生成
const setHtmlMember = () => {
/*
	<input class="member col1_Param row01_Name"			type="text"		id="mName1_01"	name="mName1"/>
	<input class="member col2_Param row01_Name"			type="text"		id="mName2_01"	name="mName2"/>
	<input class="member col1_Param row01_Comm"			type="text"		id="mComm1_01"	name="mComm1"/>
	<input class="member col2_Param row01_Comm"			type="text"		id="mComm2_01"	name="mComm2"/>
	<input class="member col1_Param row01_Back"			type="text"		id="mBack1_01"	name="mBack1"/>
	<input class="member col2_Param row01_Back"			type="text"		id="mBack2_01"	name="mBack2"/>
	<input class="member col1_Loser row01_Other lose"	type="checkbox"	id="mLoser1_01"	name="mLoser1"/>
	<input class="member col2_Loser row01_Other lose"	type="checkbox"	id="mLoser2_01"	name="mLoser2"/>
	<input class="member col1_Order row01_Other"		type="radio"	id="mOrder1_01"	name="mOrder1" value="1">
	<input class="member col2_Order row01_Other"		type="radio"	id="mOrder2_01"	name="mOrder2" value="1">
	<input class="member col1_Life  row01_Life life"	type="number"	id="mLife1_01"	name="mLife1" value="0" min="0" max="5">
	<input class="member col2_Life  row01_Life life"	type="number"	id="mLife2_01"	name="mLife2" value="0" min="0" max="5">
	<label class="member col1_Label row01_Member bar02"					id="lMember1_01">Member 01</label>
	<label class="member col2_Label row01_Member bar02"					id="lMember2_01">Member 01</label>
	<label class="member col1_Label row01_Name"							id="lName1_01">Name</label>
	<label class="member col2_Label row01_Name"							id="lName2_01">Name</label>
	<label class="member col1_Label row01_Comm"							id="lComm1_01">Comment</label>
	<label class="member col2_Label row01_Comm"							id="lComm2_01">Comment</label>
	<label class="member col1_Label row01_Back"							id="lBack1_01">Member Back</label>
	<label class="member col2_Label row01_Back"							id="lBack2_01">Member Back</label>
*/
	const tagInput		= '<input class="member col'; 
	const tagLabel		= '<label class="member col';
	const colParam 		= '_Param ';
	const colLoser 		= '_Loser ';
	const colOrder 		= '_Order ';
	const colLabel 		= '_Label ';
	const colLife		= '_Life ';
	const rowLabel		= '_Label bar02" ';
	const rowName		= '_Name" ';
	const rowComment	= '_Comm" ';
	const rowLoser		= '_Other lose" ';
	const rowOrder		= '_Other" ';
	const rowBack		= '_Back" ';
	const rowLife		= '_Name life"'
	const typeText		= 'type="text" id="m';
	const typeCheck		= 'type="checkbox" id="m';
	const typeRadio		= 'type="radio" id=m"';
	const typeNumber	= 'type="number" id="m';
	const typeLabel		= '" id="l';
	const idName		= 'Name';
	const idComm		= 'Comm';
	const idBack		= 'Back';
	const idLoser		= 'Loser';
	const idOrder		= 'Order';
	const idLife		= 'Life';
	const idMember		= 'Member';
	const optLabel		= '"></label>';
	let optInput	= function(id, side)		{return '" name="m' + id + side + '" />'}; 
	let optLife		= function(side)			{return '" name="m' + idLife + side + '" value="" min="0" max="5" onChange="setLifeScore()">'};
	let optOrder	= function(side, member)	{return '" name="m' + idOrder + side + '" value="' + member + '">'};
	let optLoser	= function(side)			{return '" name="m' + idLoser + side + '" onChange="setLifeScore()" />'};
	let optLabelBar = function(memberNum)		{return '">Member ' + memberNum + '</label>'};
	let dataFunc	= function(tag, side, col, memberNum, row, type, id, opt) {
		const data = tag + side + col + ' row' + memberNum + row + type + id + side + '_' + memberNum + opt;
		return data;
	};
	let retData = "";

	// TAB押下時の挙動をメンバー単位で移動させる為、設定タイミングを調整する
	for (let side = 1; side <= 2; side++) {
		// 名前・コメント・背景画像
		for (let member = 1; member <= YMSB_MAX_MEMBER; member++) {
			let memberNum  = ('00' + member).slice(-2);
			retData += dataFunc(tagInput, side, colParam, memberNum, rowName, typeText, idName, optInput(idName, side));
			retData += dataFunc(tagInput, side, colParam, memberNum, rowComment, typeText, idComm, optInput(idComm, side));
			if (member <= YMSB_MAX_MEMBACK) {
				retData += dataFunc(tagInput, side, colParam, memberNum, rowBack, typeText, idBack, optInput(idBack, side));
			}
		}
		// 敗退フラグ
		for (let member = 1; member <= YMSB_MAX_MEMBER; member++) {
			let memberNum  = ('00' + member).slice(-2);
			retData += dataFunc(tagInput, side, colLoser,  memberNum, rowLoser, typeCheck, idLoser, optLoser(side));
		}
		// オーダー
		for (let member = 1; member <= YMSB_MAX_MEMBER; member++) {
			let memberNum  = ('00' + member).slice(-2);
			retData += dataFunc(tagInput, side, colOrder, memberNum, rowOrder, typeRadio, idOrder, optOrder(side, member));
		}
		// ライフ
		for (let member = 1; member <= YMSB_MAX_MEMBER; member++) {
			let memberNum  = ('00' + member).slice(-2);
			retData += dataFunc(tagInput, side, colLife,  memberNum, rowLife, typeNumber, idLife, optLife(side));
		}
	}

	// ラベルは一まとめにループ
	for (let side = 1; side <= 2; side++) {
		for (let member = 1; member <= YMSB_MAX_MEMBER; member++) {
			let memberNum  = ('00' + member).slice(-2);
			retData += dataFunc(tagLabel, side, colLabel, memberNum, rowLabel, typeLabel, idMember, optLabelBar(memberNum));
			retData += dataFunc(tagLabel, side, colLabel, memberNum, rowName, typeLabel, idName, optLabel);
			retData += dataFunc(tagLabel, side, colLabel, memberNum, rowComment, typeLabel, idComm, optLabel);
			if (YMSB_MAX_MEMBACK >= member) {
				retData += dataFunc(tagLabel, side, colLabel, memberNum, rowBack, typeLabel, idBack, optLabel);
			}
		}
	}
	return retData;
} 

// ■■ 10先スコアデータ生成
const setHtmlScore = (isExpert) => {
	/*
	<label  class="LB rowSets col01" id="lLB_no01">01</label>
	<select class="LB rowChek1 col01 round" id="LBs1_01" name="YMSB_LB_1">
	<select class="LB rowChek2 col01 round" id="LBs2_02" name="YMSB_LB_2">
	<option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option></select>
	// チェックボックスの場合はこちら↓
	<input  class="LB rowChek1 col01" type="checkbox" id="LBs1_01" name="YMSB_LB_1" />
	<input  class="LB rowChek2 col01" type="checkbox" id="LBs2_02" name="YMSB_LB_2" />
	*/
	let tagLabel = function(setNum) {
		return '<label  class="LB rowSets No col' + setNum + '" id="lLB_no' + setNum + '">' + setNum + '</label>'};
	const selectOption = '" /><option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option></select>';
	let tagSelect = function(side, setNum) {
		return '<select class="LB rowChek' + side + ' col' + setNum + ' round" id="LBs' + side + '_' + setNum + '" name="YMSB_LB_' + side + selectOption};
	let data = "";
	let tagCheck = function(side, setNum) {
		return '<input  class="LB rowChek' + side + ' col' + setNum + '" type="checkbox" id="LBs' + side + '_' + setNum + '" name="YMSB_LB_' + side + '" />'};

	for (let set = 1; set <= YMSB_MAX_SETS; set++) {
		let setNum  = ('00' + set).slice(-2);
		data += tagLabel(setNum);
		if (isExpert) {
			data += tagSelect("1", setNum);
			data += tagSelect("2", setNum);
		}
		else {
			data += tagCheck("1", setNum);
			data += tagCheck("2", setNum);
		}
	}
	return data;
};

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	タブ設定
//	https://blog-and-destroy.com/7389
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
jQuery(function($){
	jQuery('.tab').click(function(){
		jQuery('.is-active').removeClass('is-active');
		jQuery(this).addClass('is-active');
		jQuery('.is-show').removeClass('is-show');
		// クリックしたタブからインデックス番号を取得
		const index = jQuery(this).index();
		// クリックしたタブと同じインデックス番号をもつコンテンツを表示
		jQuery('.panel').eq(index).addClass('is-show');
	});
});

// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	ツールチップ設定
//	https://gimmicklog.com/jquery/376/
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
jQuery(function () {
	const FADE_SPEED = 100;
	if (YMSB_TOOLTIP_ON) {
		jQuery('.tooltip-button, .tooltip-top, .tooltip').hide();
		jQuery('button, label').hover(
			function(){jQuery(this).children('.tooltip-button, .tooltip-top, .tooltip').fadeIn(FADE_SPEED);},
			function(){jQuery(this).children('.tooltip-button, .tooltip-top, .tooltip').fadeOut(FADE_SPEED);}
		);
	}
});
